<?php
namespace cloud\apps\gamecloud;


function devlist($data)
{
	global $user;
	
	$optional = array();
	$result = array(
		'rows'		=> array(),
		'total'		=> 0,
		'fail'		=> 0,
		'page'		=> 0,
		'limit'		=> 0
	);

	$now = strtotime("now");
	$result['now'] = $now;

	// set custom options
	if(format_and_push($data, 'grpid', $optional, '', 'int', false) == false)
		$optional['grpid'] = 0;
	if($optional['grpid'] == 10000) $optional['grpid'] = 0;

	if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
		$optional['keyword'] = iconv('utf-8', 'gbk', $optional['keyword']);
		if (strpos($optional['keyword'], "(") != false && strpos($optional['keyword'], ")") != false) {
			$pos = strpos($optional['keyword'], "(");
			$optional['keyword'] = substr($optional['keyword'], $pos);
		}
		$optional['keyword'] = addslashes($optional['keyword']);
		$optional['keyword'] = strtolower($optional['keyword']);
	}
	else
		$optional['keyword'] = '';
	
	if(format_and_push($data, 'sort', $optional, '', 'string', false) == false)
		$optional['sort'] = 'serialno';

	if(format_and_push($data, 'expire', $optional, '', 'int', false) == false)
		$optional['expire'] = 0;
	
	if(format_and_push($data, 'page', $result, '', 'int', false) == false)
		$result['page'] = 1;
	
	if(format_and_push($data, 'limit', $result, '', 'int', false) == false)
		$result['limit'] = 20;
	else
		if($result['limit'] <= 0) $result['limit'] = 20;

	if(format_and_push($data, 'g_ascdesc', $optional, '', 'string', false)) {
		if ($optional['g_ascdesc'] != 'desc')
			$optional['g_ascdesc'] = 0;
		else
			$optional['g_ascdesc'] = 1;
	}
	else
		$optional['g_ascdesc'] = 0;

	// 设置用户组
	if(\cloud\apps\work\project\project_enable(array())) {
		$optional['grpid'] = \cloud\apps\work\project\in_work_grpidstr(1, $optional['grpid']);
		if($optional['grpid'] === false)
			return $result;
		if(empty($optional['grpid']) && !is_supadmin($user->username))
			return $result;
	}
	else {
		if(!is_supadmin($user->username)) {
			if($user->grp == '')
				return $result;
			if($optional['grpid'] == 0)
				$optional['grpid'] = $user->grp;
			else {
				$grpids = explode(',', $user->grp);
				if(in_array($optional['grpid'], $grpids) == false) {
					return $result;
				}
			}
		}
	}
	

	switch($optional['sort']) {
		case "serialno":
		$sort_name = 1;break;
		case "lasttime":
		$sort_name = 2;break;
		case "ipcnt":
		$sort_name = 3;break;
		case "delay":
		$sort_name = 4;break;
		case "bpsin":
		$sort_name = 5;break;
		case "bpsout":
		$sort_name = 6;break;
		case "name":
		$sort_name = 7;break;
		case "enabled":
		$sort_name = 8;break;
		default:
		$sort_name=1;break;
	}

	$cmd = DATAEYE . " gamecloud list page={$result['page']}";
	$cmd.= " limit={$result['limit']}";
	$cmd.= " usergrp={$optional['grpid']} sch='{$optional['keyword']}'";
	$cmd.= " sortname={$sort_name} sortdesc={$optional['g_ascdesc']}";
	$cmd.= " expire={$optional['expire']}";

	exec($cmd, $out, $ret);

	foreach($out as $val) {
		$row = explode(' ', $val);
		if ($row[0] == "ipaddr") 
			continue;
		if (count($row) < 3) {
			if(($pos = strpos($row[0], 'total=')) === 0)
				$result['total'] = intval(substr($row[0], 6));
			else
			if(($pos = strpos($row[0], 'fail=')) === 0)
				$result['fail'] = intval(substr($row[0], 5));
			continue;
		}

		$grpid = (int)$row[1];
		if($grpid == 10000) $grpid = 0;

		// $row[4]: Panabit 上配置的名称，$row[23]：云平台上配置的名称
		$sysname	= to_utf8($row[4]);
		$serialno	= to_utf8($row[0]);

		$license_end = intval($row[6]);
		
		array_push($result['rows'], array(
			"name"			=> $sysname,
			"license_start"	=> intval($row[5]),
			"license_end"	=> $license_end,
			"license_ipcnt"	=> intval($row[11]),
			"usedays"		=> ($row[6] == 0 ? '' : intval(($license_end - $now) / 86400)),
			"serialno"		=> $serialno,
			"state"			=> $row[15],
			"maxipcnt"		=> intval($row[17]),
			"waitime_left"	=> intval($row[16]),
			"bpsout"		=> intval($row[8]),
			"bpsin"			=> intval($row[7]),
			"lasttime"		=> intval($row[9]),
			"ipcnt"			=> intval($row[10]),
			"delay_cur"		=> intval($row[12]),
			"delay_min"		=> intval($row[13]),
			"delay_max"		=> intval($row[14]),
			"servertime"	=> $now,
			"grpid"			=> $grpid,
			"enabled"		=> intval($row[2]),
			"l2tp_state"	=> $row[3],
			"outip"			=> long2ip($row[17])
		));
	}

	return $result;
}
