layui.use('element', function() {
	var $ = layui.jquery,
		element = layui.element;

	var lastTime = 0;
	var serialno = getURL_val("serialno");
	var hosthd = window.document.location.protocol + '//' + window.document.location.hostname;
	var sshUrl = '';

	//监听关闭或刷新页面，提示是否继续
	document.body.onbeforeunload = function() {
		window.event.returnValue = '';
	}

	document.title = '终端设备 ' + serialno;

	function open_remote(serialno, callback) {
		if(!serialno) {
			layer.msg('无效的设备编号。', {
				icon: 2
			});
			return;
		}
		var index = layer.load(0, {
			shade: 0
		});

		$.ajax({
			url: 'api.php?r=gateway@sshport_open',
			data: {
				serialno: serialno,
				webenable: 0,
				sshenable: 1
			},
			dataType: 'json',
			type: 'post',
			success: function(d) {
				layer.close(index);
				if (ajax_resultCallBack(d) == false) {
					layer.msg(d.msg, {
						icon: 5
					});
					return;
				}

				if (typeof callback == 'function')
					callback(d.data);
			},
			error: function() {
				layer.close(index);
				layer.msg('连接失败，请稍后再试。', {
					icon: 2
				});
			}
		});
	}

	//0.4秒创建一次时间戳（页面心跳）
	setInterval(function() {
		var curtime = new Date().getTime();
		localStorage.setItem("webssh" + serialno, curtime);
	}, 400);

	function opentab()
	{
		//新增一个Tab项
		//页面宽高
		var viewH = $(window).height();
		var frameH = viewH - $('.tabTitle').outerHeight() - $('.addBtn').outerHeight() - 30;

		element.tabAdd('demo', {
			title: serialno,
			content: '<iframe src="' + sshUrl + '" width="100%" height="' + frameH + '" allowfullscreen="true"></iframe>',
			id: new Date().getTime() //实际使用一般是规定好的id，这里以时间戳模拟
		});
		$('.tabTitle li:last').click();
	}

	// 复制tab
	$('.copysshBtn').on('click', function(e) {
		var tm = new Date().getTime();
		if((tm - lastTime) > 120000) {
			open_remote(serialno, function(d) {
				var arg = "ssh://root@" + window.document.location.hostname + ":" + d.sshport;
				var web_port = '/webssh';

				if (d.openid) {
					if (d.webssh_port)
						web_port = ':' + d.webssh_port + '/';
					else
					if (window.document.location.port)
						web_port = ':' + window.document.location.port + web_port;
					sshUrl = hosthd + web_port + '?openid=' + d.openid;
				} else {
					layer.msg("当前版本不支持WEB SSH,请复制" + arg + "到浏览器打开");
					return;
				}
				
				opentab();
				lastTime = tm;
			});
		}
		else 
			opentab();
	});

	$('.copysshBtn').click();

	window.onresize = function() {
		var viewH = $(window).height();
		var frameH = viewH - $('.tabTitle').outerHeight() - $('.addBtn').outerHeight() - 30;
		$('iframe').attr('height', frameH);
	};
});
