// 每页数据量记忆
var _tb_paga = dump_tb_paga();
var _tb_paga_tmout = _tb_paga.tmout;
_tb_paga = _tb_paga.paga;
function dump_tb_paga()
{
	var tmout = 0, paga = 20;
	var tb_paga = $.cookie("tb_paga");
	if(tb_paga) {
		if((page = tb_paga.split('.')).length == 2) {
			tmout = strToInt(page[1]);
			paga = strToInt(page[0]);
			if(paga <= 0)
				paga = 20;
		}
	}
	return {paga: paga, tmout: tmout};
}
function get_tb_paga() {
	return _tb_paga;
}
function set_tb_paga(paga) {
	if(!paga) return;
	var now = $.myTime.CurTime();
	var opt, npage = strToInt(paga);
	if(_tb_paga != npage) {
		opt = dump_tb_paga();
		if(now > opt.tmout) {
			$.cookie("tb_paga", paga + '.' + now, {expires: 31});
			_tb_paga = npage;
			_tb_paga_tmout = now;
		}
	}
}

layui.use(['element', 'table', 'form'], function() {
	var element = layui.element;
	var table = layui.table;
	var form = layui.form;
	var timer = new taskTimer();
	var tablelns;

	table.render({
		elem: '#ipfwlist',
		even: true,
		loading: false,
		url: 'api.php?r=ipfw@list',
		method: 'post',
		limit: get_tb_paga(),
		skin: 'line',
		initSort: {
			field: 'id',
			type: 'asc'
		},
		request: {
			pageName: 'page',
			limitName: 'limit'
		},
		defaultToolbar: ['filter', 'print', 'exports', {
			title: '提示',
			layEvent: 'LAYTABLE_TIPS',
			icon: 'layui-icon-tips'
		}],
		page: {
			layout: ['limit', 'count', 'prev', 'page', 'next', 'skip'],
			groups: 3
		},
		parseData: function(res) {
			res.count = res.data.total;
			res.data = res.data.rows;
			res.code = res.ret;
			res.msg = res.msg;

			var e = $('#ipfwlist').parent();
			set_tb_paga(e.find('.layui-laypage-limits select').val());
		},
		done: function(res, curr, count) {},
		cols: [
			[
				{
					fixed: 'left',
					type: 'checkbox',
					width: 25
				}, {
					field: 'id',
					title: '序号',
					width: 80
				},  
				{
					field: 'dir',
					title: '流向',
					templet: function(d) {
						if(d.dir == 'any')
							return '任意';
						if(d.dir == 'in')
							return '流入';
						if(d.dir == 'out')
							return '流出';
						return d.dir;
					}
				}, 
				{
					field: 'srcip',
					title: '源IP',
					templet: function(d) {
						if(d.intype == 'any' || d.intype == 'me')
							return d.intype;
						return d.srcip;
					}
				}, 
				{
					field: 'dstip',
					title: '目标IP',
					templet: function(d) {
						if(d.outtype == 'any' || d.outtype == 'me')
							return d.outtype;
						return d.dstip;
					}
				}, 
				{
					field: 'proto',
					title: '协议',
				},  
				{
					field: 'act',
					title: '动作',
					templet: function(d) {
						if(d.act == 'allow')
							return '允许';
						if(d.act == 'deny')
							return '阻断';
						return d.act;
					}
				},  
				{
					field: '',
					title: '匹配in/out',
					templet: function(d) {
						return d.in+ '/' +d.out;
					}
				}, {
					field: 'desc',
					title: '备注',
				}, {
					field: 'operate',
					width: 100,
					title: '操作',
					templet: function(d) {
						return '<span class="setBtn" lay-event="edit">编辑</span>' + 
							   ' | <span class="setBtn" lay-event="del">删除</span>';
					}
				}
			]
		]
	});

	table.on('tool(ipfwlist)', function(obj) {
		var data = obj.data,
			event = obj.event;

		if (event == 'edit') {
			ipfw_policy(data);
		}
		else
		if (event == 'del') {
			layer.confirm('确定要删除序号为“' + data.id + '”规则吗？', function(index){
				$.ajax({
					url: 'api.php?r=ipfw@remove',
					data: {
						id: data.id
					},
					type: 'post',
					dataType: 'json',
					success: function(d) {
						if (ajax_resultCallBack(d) === false) {
							layer.msg(d.msg, {
								icon: 5
							});
							return;
						}
						if (d.msg) layer.msg(d.msg, {
							icon: 1
						});

						search_operate();
						layer.close(index);
					},
					error: function() {
						layer.msg('获取数据失败，请稍后再试。', {
							icon: 2
						});
					}
				});
			});
		}
	});
	
	$('.search_operate').on('click', function() {
		search_operate(1);
	});
	
	$('.keyword').on('click', function() {
		
		search_operate(1);
	});

	form.on('select(filter-act)', function(data) {
		search_operate(1);
	});	

	function ipfw_policy(rule) 
	{
		layer.open({
			type: 1,
			title: (rule?'修改防火墙规则':'添加防火墙规则'),
			area: ['480px', '460px'],
			shadeClose: true,
			resize: false,
			btnAlign: 'c',
			btn: ['确认'],
			content: $('#tpl-ipfw-policy-add').html(),
			mysubmit: function(index, layero) {
				var data = form.val('ipfw-policy-add');
				if(rule)
					data.oldid = rule.id;

				$.ajax({
					url: 'api.php?r=ipfw@' + (rule?'save':'add'),
					data: data,
					type: 'post',
					dataType: 'json',
					success: function(d) {
						if (ajax_resultCallBack(d) === false) {
							layer.msg(d.msg, {
								icon: 5
							});
							return;
						}
						if (d.msg) layer.msg(d.msg, {
							icon: 1
						});
						layer.close(index);
						search_operate();
					},
					error: function() {
						layer.msg('获取数据失败，请稍后再试。', {
							icon: 2
						});
					}
				});
			},
			success: function(layero, index) {
				var that = this;
				if(typeof rule == 'object') {
					form.val('ipfw-policy-add', rule);
					
					if(rule.intype == 'ip')
						layero.find('input[name="srcip"]').show();
					else
						layero.find('input[name="srcip"]').hide();
					if(rule.outtype == 'ip')
						layero.find('input[name="dstip"]').show();
					else
						layero.find('input[name="dstip"]').hide();
				}
				
				layero.find('.layui-layer-content').css('overflow', 'inherit');
				form.render(null, 'ipfw-policy-add');
				form.on('submit(ipfw-policy-add)', function(data) {
					that.mysubmit(index, layero);
					return false;
				});
				
				form.on('select(intype)', function(data){
					if(data.value == 'ip')
						layero.find('input[name="srcip"]').show();
					else
						layero.find('input[name="srcip"]').hide();
				});   
				form.on('select(outtype)', function(data){
					if(data.value == 'ip')
						layero.find('input[name="dstip"]').show();
					else
						layero.find('input[name="dstip"]').hide();
				});  
				element.on('select(ipfw-tab)', function(data){
					if(data.index == 0)
					search_operate();
					if(data.index == 1) {
					ipfw_option();
					}
				});
				
			},
			yes: function(index, layero) {
				this.mysubmit(index, layero);
			}
		});
	}

	$('.toolleft2 button').on('click', function(obj) {
		var event = obj.currentTarget.getAttribute('lay-filter');
		var checkStatus = table.checkStatus('ipfwlist');
		var count, success, i, rules = [];
		checkStatus.data.forEach(function(e, i) {
			rules.push(e.id);
		});
		switch (event) {
			case 'del':
				if (rules.length <= 0) {
					layer.msg('请先选择要删除的规则。');
					return;
				}
				layer.confirm('确定删除选中的策略规则吗？', {
					icon: 0,
					title: '设备删除'
				}, function(index) {
					count = success = 0;
					for(i = 0; i < rules.length; i++) {
						$.ajax({
							url:'api.php?r=ipfw@remove',
							data:{ id: rules[i] },
							dataType:'json',
							type:'post',
							async: false,
							success:function(data) {
								count++;
								if(data.ret) {
									if(data.msg) {
										layer.msg(data.msg, {
											icon: 5
										});
									}
									if(success)
										search_operate(0);
									layer.close(index);
									return;
								}
								success++;
							}
						});
					}

					if(success)
						search_operate(0);
					
					layer.close(index);
				});

				break;
			case 'add':
				ipfw_policy(0);
				break;
			default:
				break;
		}
	});
	
	
	function search_operate(page, obj) {
		var where = {
			keyword: $.trim($('.keyword').val()),
			act: $.trim($('select[lay-filter="filter-act"]').val()),
		};
		var option = {
			method: 'post',
			where: where
		};
		if (typeof page == "number") {
			if (page > 0)
				option.page = {
					curr: page
				}; //重新从第 1 页开始
		} else
			page = 0;

		table.reloadExt('ipfwlist', option);
	}

	function ipfw_option() {
		$.ajax({
			url: 'api.php?r=ipfw@status',
			success(d) {
				if (ajax_resultCallBack(d) == false) return;
				form.val('form-ipfw-optione', { enable: d.data});
			}
		});
	}

	element.on('tab(ipfw-tab)', function(data){
		if(data.index == 0)
			search_operate();
		if(data.index == 1) {
			ipfw_option();
		}
	});
	
	form.on('submit(form-ipfw-optione)', function(data){
		var that = this;
		if(that.__submit) return false;
		that.__submit = 1;
		var data = form.val('form-ipfw-optione');
		$.ajax({
			url: 'api.php?r=ipfw@status',
			data: data,
			dataType:'json',
			type:'post',
			success:function(d) {
				that.__submit = 0;
				if (ajax_resultCallBack(d) === false) {
					layer.msg(d.msg, {
						icon: 5
					});
					return;
				}
				if (d.msg) layer.msg(d.msg, {
					icon: 1
				});
				ipfw_option();
			},
			error: function() {
				that.__submit = 0;
			}
		});
		return false;
	});

	form.render(null, 'form-ipfw-optione');
});
