<?php
namespace cloud\apps\netoff\object;

define('API_WXDENY_DIR', '/usr/logdata/api_wxdeny');

function is_utf8($word)   
{
	if (preg_match("/^([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){1}/",$word) == true || preg_match("/([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){1}$/",$word) == true || preg_match("/([".chr(228)."-".chr(233)."]{1}[".chr(128)."-".chr(191)."]{1}[".chr(128)."-".chr(191)."]{1}){2,}/",$word) == true)
	{
		return true;
	}else{   
		return false;   
	}   
}

function select($data)
{
	global $nidb;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';
/*
	if(format_and_push($data, 'disabled', $optional, '', 'int', false))
		$where_str .= "`disabled` = " . $optional['disabled'] . " and ";
	else
		$where_str .= "`disabled` < " . TB_ROW_DEL_VALUE . " and ";
	
	if(format_and_push($data, 'upstartm', $optional, '', 'int', false))
		$where_str .= "`update_time` >= " . $optional['upstartm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false)) 
		$where_str .= "`update_time` < " . $optional['upendtm']  . " and ";

	if(format_and_push($data, 'startm', $optional, '', 'int', false))
		$where_str .= "`create_time` >= " . $optional['startm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false))
		$where_str .= "`create_time` < " . $optional['endtm']  . " and ";
*/
	// set custom options
	if(format_and_push($data, 'id', $optional, '', 'int', false))
		$where_str .= "`id` = " . $optional['id']  . " and ";

	if(format_and_push($data, 'serialno', $optional, 'license_id12', 'string', false)) {
		$where_str .= "`license_id12` = ? and ";
		array_push($values, $optional['license_id12']);
	}

	if(format_and_push($data, 'name', $optional, 'sysname', 'string', false)) {
		$where_str .= "`sysname` = ? and ";
		array_push($values, "%" . $optional['sysname'] . "%");
	}

	if(isset($data['keyword'])) {
		if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
			$where_str .= "(`license_id12` like ? or `sysname` like ? or `tips` like ? or `myevent` like ?) and ";
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$order_map = array(
		"id",
		"myevent",
		"openid",
		"license_id12",
		"status",
		"isupdate",
		"sysname",
		"tips",
	);

	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($data['columns'][$op['column']]['data'])) {
				if(in_array($data['columns'][$op['column']]['data'], $order_map))
					array_push($order, "`" . $data['columns'][$op['column']]['data'] . "` " . $op['dir']);
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by ' . implode(', ', $order);
	else
		$order_by = 'order by `id` desc';

	$sql = "select count(*) as `total` from weixin_brokennet $where_str";

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	if(isset($data['simplify'])) {
		$keys = '`myevent` as `event`,
			`license_id12` as `serialno`,
			`status`,
			`sysname` as `name`,
			`tips`';
	}
	else{
		$keys = '`id`,
			`myevent` as `event`,
			`openid`,
			`license_id12` as `serialno`,
			`status`,
			`old_status`,
			`sysname` as `name`,
			`tips`';
	}

	$sql = "select $keys from weixin_brokennet $where_str $order_by limit ? offset ? ";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);


	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

//	$result['page'] = intval($optional['offset'] / $optional['limit']);
	$result['limit'] = $optional['limit'];
	$result['rows'] = $rows;

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

function add($data)
{
	global $nidb;


	$optional = array();
/*
	if(format_and_push($data, 'openid', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'openid不能为空。');
		return false;
	}

	if(preg_match("/^([a-zA-Z0-9-_]{20,})$/", $optional['openid'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "OPENID“{$optional['openid']}”不正确！");
		return false;
	}
*/
	if(format_and_push($data, 'serialno', $optional, 'license_id12', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $optional['license_id12'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$optional['license_id12']}”不正确！");
		return false;
	}

	if(format_and_push($data, 'event', $optional, 'myevent', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
		return false;
	}

	format_and_push($data, 'tips', $optional, '', 'string', false);


	$sql = "select id from weixin_brokennet where `license_id12` = ? and `myevent` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $optional['license_id12'], \PDO::PARAM_STR);
		$sth->bindParam(2, $optional['myevent'], \PDO::PARAM_STR);
		$sth->execute($values);

		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($row) {
		set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['myevent']}”对象已存在。");
		return false;
	}

	$sysname = "";
	if (!empty($optional['license_id12'])) {
		$cmd = DATAEYE . " device get license_id12={$optional['license_id12']}";
		exec($cmd, $out, $ret);
		$license_id12 = "";
		foreach($out as $val) {
			list($tag, $val) = explode('=', $val);
			if ($tag == "name") {
				$sysname = $val;
				$license_id12 = $optional['license_id12'];
			}
		}

		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8", $sysname);
		}

		if($license_id12 != $optional['license_id12']) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['license_id12']}”设备不存在。");
			return false;
		}
	}
	

	$optional['birth'] = time();
	// $optional['isupdate'] = 0;
	$optional['sysname'] = $sysname;

	try {
		if(insert_data('weixin_brokennet', $optional) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$optional['id'] = $nidb->lastInsertId();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $optional;
}

function save($data)
{
	global $nidb;


	$where = array();
	$optional = array();
/*
	if(format_and_push($data, 'openid', $optional, '', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'openid不能为空。');
		return false;
	}

	if(preg_match("/^([a-zA-Z0-9-_]{20,})$/", $optional['openid'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "OPENID“{$optional['openid']}”不正确！");
		return false;
	}
*/
	if(format_and_push($data, 'id', $where, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '资源ID不能为空！');
		return false;
	}

	if(format_and_push($data, 'serialno', $optional, 'license_id12', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $optional['license_id12'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$optional['license_id12']}”不正确！");
		return false;
	}

	if(format_and_push($data, 'event', $optional, 'myevent', 'string', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
		return false;
	}

	format_and_push($data, 'tips', $optional, '', 'string', false);


	$sql = "select `id` from weixin_brokennet where `id` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $where['id'], \PDO::PARAM_STR);
		$sth->execute();

		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_EXP, __function__, "资源不存在。");
		return false;
	}

	$sql = "select `id` from weixin_brokennet where `id` != ? and `license_id12` = ? and `myevent` = ? limit 1";

	try {
		$sth = $nidb->prepare($sql);

		$sth->bindParam(1, $where['id'], \PDO::PARAM_INT);
		$sth->bindParam(2, $optional['license_id12'], \PDO::PARAM_STR);
		$sth->bindParam(3, $optional['myevent'], \PDO::PARAM_STR);
		$sth->execute($values);

		$row = $sth->fetch(\PDO::FETCH_LAZY);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if($row) {
		set_errmsg(MSG_LEVEL_EXP, __function__, "新对象“{$optional['myevent']}”已存在。");
		return false;
	}

	$sysname = "";
	if (!empty($optional['license_id12'])) {
		$cmd = DATAEYE . " device get license_id12={$optional['license_id12']}";
		exec($cmd, $out, $ret);
		$license_id12 = "";
		foreach($out as $val) {
			list($tag, $val) = explode('=', $val);
			if ($tag == "name") {
				$sysname = $val;
				$license_id12 = $optional['license_id12'];
			}
		}

		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8", $sysname);
		}

		if($license_id12 != $optional['license_id12']) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$optional['license_id12']}”设备不存在。");
			return false;
		}
	}
	

	// $optional['birth'] = time();
	// $optional['isupdate'] = 0;
	$optional['sysname'] = $sysname;

	try {
		if(update_data('weixin_brokennet', $optional, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $optional;
}

function deny($data)
{
	global $nidb;


	$values = array();


	if(isset($data['allow']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '操作方法不能为空。');
		return false;
	}
	$allow = intval($data['allow']);
	
	// 不为 0 则发送微信消息
	if(isset($data['wxmsg']) && intval($data['wxmsg']))
		$isupdate = 127;
	else
		$isupdate = 1;

	if(isset($data['ids']) == false) {

		if(add($data) === false)
			set_errmsg(MSG_LEVEL_ARG, __function__, '');
//			return false;

		if(format_and_push($data, 'serialno', $values, 'license_id12', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
			return false;
		}
		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $values['license_id12'], $match) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$values['license_id12']}”不正确！");
			return false;
		}

		if(format_and_push($data, 'event', $values, 'myevent', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
			return false;
		}

		$sql = "update weixin_brokennet set `status` = ${allow}, `isupdate` = {$isupdate}";
		$sql.= " where `license_id12` = ? and `myevent` = ? ";

		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $values['license_id12'], \PDO::PARAM_STR);
			$sth->bindParam(2, $values['myevent'], \PDO::PARAM_STR);
			$ret = $sth->execute();
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}
	else {
		if(is_array($data['ids']) == false)
			$data['ids'] = explode(',', $data['ids']);

		foreach($data['ids'] as $val) {
			$id = intval($val);
			if($id <= 0){
				set_errmsg(MSG_LEVEL_ARG, __function__, "删除对象“{$id}”不正确。");
				return false;
			}
			array_push($values, $id);
		}
		
		if(count($values) == 0) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '删除对象不能为空。');
			return false;
		}
		
		$idstr = '?';
		if(count($values) > 1)
			$idstr .= str_repeat(',?' , count($values) - 1);

		$sql = "update weixin_brokennet set `status` = ${allow}, `isupdate` = {$isupdate} where `id` in($idstr)";
		
		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($values);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}

	if($ret == false) 
		return false;

	return $sth->rowCount();
}

function remove($data)
{
	global $nidb;


	$values = array();

	if(isset($data['ids']) == false) {
		if(format_and_push($data, 'serialno', $values, 'license_id12', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '12位编号不能为空。');
			return false;
		}
		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $values['license_id12'], $match) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, "用户“{$values['license_id12']}”不正确！");
			return false;
		}

		if(format_and_push($data, 'event', $values, 'myevent', 'string', false) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '操作对象不能为空。');
			return false;
		}
		
		$sql = "delete from weixin_brokennet where `license_id12` = ? and `myevent` = ? ";
		
		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $values['license_id12'], \PDO::PARAM_STR);
			$sth->bindParam(2, $values['myevent'], \PDO::PARAM_STR);
			$ret = $sth->execute();
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}
	else {
		if(is_array($data['ids']) == false)
			$data['ids'] = explode(',', $data['ids']);

		foreach($data['ids'] as $val) {
			$id = intval($val);
			if($id <= 0){
				set_errmsg(MSG_LEVEL_ARG, __function__, "删除对象“{$id}”不正确。");
				return false;
			}
			array_push($values, $id);
		}
		
		if(count($values) == 0) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '删除对象不能为空。');
			return false;
		}
		
		$idstr = '?';
		if(count($values) > 1)
			$idstr .= str_repeat(',?' , count($values) - 1);

		$sql = "delete from weixin_brokennet where id in($idstr)";

		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($values);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}


	if($ret == false) 
		return false;

	return true;
}

function clean($data)
{
	global $nidb;


	$ids = array();
	$sync = 0;
	if(isset($data['sync']))
		$sync = intval($data['sync']);
	if($sync) {
		if(is_string($data['ids'])) {
			$ids = explode(',', $data['ids']);
			foreach($ids as $key => $val) {
				$ids[$key] = intval($val);
			}
		}
		else
		if(is_array($data['ids']))
			$ids = $data['ids'];
	}

	if(isset($data['dev']) == false || empty($data['dev'])) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '要清空的设备不能为空。');
		return false;
	}
	
	if(is_string($data['dev']))
		$devs = explode(',', $data['dev']);
	else
	if(is_array($data['dev']))
		$devs = $data['dev'];
	else {
		set_errmsg(MSG_LEVEL_ARG, __function__, '指定要清空的设备不正确。');
		return false;
	}
	
	$values = array();
	$count = 0;
	foreach($devs as $dev) {
		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $dev, $match) == false) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '指定要清空的设备编号不正确。');
			return false;
		}
		array_push($values, $dev);
	}

	$idstr = '?';
	if(count($values) > 1)
		$idstr .= str_repeat(',?' , count($values) - 1);

	$sql = "delete from weixin_brokennet where `license_id12` in($idstr)";

	try {
		$sth = $nidb->prepare($sql);
		$ret = $sth->execute($values);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if($sync && count($ids) > 0 && count($ids) <= count($values)) {
		if(!is_dir(API_WXDENY_DIR))
			mkdir(API_WXDENY_DIR);
		foreach($ids as $index => $devid) {
			if($devid < 0 || $devid > 65535)
				continue;

			$content = "devid={$devid}";
			file_put_contents(API_WXDENY_DIR . "/{$values[$index]}", $content);
		}
	}

	return true;
}

function upload($data)
{
	global $nidb, $user;

	$optional = array();

	if(\cloud\apps\work\project\project_enable(array())) {
		if(!\cloud\apps\work\project\in_work_project(ROLE_TECHN)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足！');
			return false;
		}
	}
	else
	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	$upfile = $_FILES['file'];
	if (isset($upfile['name']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '导入失败！');
		return false;
	}
	
	if (strpos($upfile['name'], ".php") !== false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '无效的导入文件！');
		return false;
	}
	
	$target = "/tmp/netoff_object";
	if (file_exists($target)) 
		unlink($target);

	if (!move_uploaded_file($upfile['tmp_name'], $target)) {
		unlink($upfile['tmp_name']);
		set_errmsg(MSG_LEVEL_ARG, __function__, '文件导入失败！');
		return false;
	}
	if(isset($optional['cover']))
		$cover = intval($optional['cover']);
	else
		$cover = 0;
		
	$fp = fopen($target, 'r');
	if(!$fp) {
		unlink($target);
		set_errmsg(MSG_LEVEL_ARG, __function__, '打开文件导入失败！');
		return false;
	}
	
	$optional = array(
		'birth'	=> time()
	);
	$dupdate = array(
		'birth'	=> time()
	);
	while (!feof($fp)) {
		if(($buf = fgets($fp)) === false)
			break;
		if(empty($buf = trim($buf, "\t\n\r\0\x0B")))
			continue;

		$col = explode(' ', $buf);
		if(count($col) < 3)
			continue;
		
		$fdata = array();
		foreach($col as $val) {
			if($val != '')
				array_push($fdata, $val);
		}
		if(count($fdata) < 3)
			continue;
		
		$status = ($fdata[0] == 'allow'?1:0);
		$serialno = $fdata[1];
		$myevent = $fdata[2];
		if(count($fdata) > 3)
			$tips = $fdata[3];
		else
			$tips = '';

		if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $serialno, $match) == false){
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$serialno}”编号格式不正确。");
			return false;
		}
		
		$cmd = DATAEYE . " device get license_id12={$serialno}";
		exec($cmd, $out, $ret);
		$sysname = '';
		foreach($out as $val) {
			list($tag, $val) = explode('=', $val);
			if ($tag == "name") {
				$sysname = $val;
			}
		}
		unset($out);

		if ($sysname != "") {
			if (!is_utf8($sysname) || json_encode($sysname) == false)
				$sysname = iconv("gbk", "utf-8", $sysname);
		}

		if($serialno != $serialno) {
			set_errmsg(MSG_LEVEL_EXP, __function__, "“{$serialno}”设备不存在。");
			return false;
		}
		
		$sql = "select `status` from weixin_brokennet";
		$sql.= " where `license_id12` = '{$serialno}' and `myevent` = ? ";
		try {
			$sth = $nidb->prepare($sql);
			$sth->bindParam(1, $myevent, \PDO::PARAM_STR);
			$sth->execute($values);
			$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
		
		if(count($rows) > 0) {
			if($cover) {
				$dupdate['status'] = $status;
				$dupdate['sysname'] = $sysname;
				if(!empty($tips))
					$dupdate['tips'] = $tips;

				$where = array(
					'myevent'	=> $myevent,
					'license_id12'	=> $serialno
				);
				try {
					if(update_data('weixin_brokennet', $dupdate, $where) === false) {
						$errmsg = implode(' ', $nidb->errorInfo());
						set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
						return false;
					}
				}
				catch (\NiDBException $e) {
					set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
					return false;
				}
			}
			continue;
		}

		$optional['myevent'] = $myevent;
		$optional['license_id12'] = $serialno;
		$optional['status'] = $status;
		$optional['old_status'] = $status?0:$status;
		$optional['sysname'] = $sysname;
		$optional['tips'] = $tips;

		try {
			if(insert_data('weixin_brokennet', $optional) === false) {
				$errmsg = implode(' ', $nidb->errorInfo());
				set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
				return false;
			}
		}
		catch (\NiDBException $e) {
			set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
			return false;
		}
	}
	fclose($fp);

	return true;
}

function export($data)
{
	global $nidb, $user;


	$optional = array();

	if(\cloud\apps\work\project\project_enable(array())) {
		if(!\cloud\apps\work\project\in_work_project(ROLE_TECHN)) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足！');
			return false;
		}
	}
	else
	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	$where_str = '';
	$values = array();
	if(isset($data['keyword'])) {
		if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
			$where_str .= "(`license_id12` like ? or `sysname` like ? or `tips` like ? or `myevent` like ?) and ";
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
			array_push($values, "%" . $optional['keyword'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$keys = "concat_ws(' ', if(`status` = 0, 'deny', 'allow'), `license_id12`, `myevent`, `tips`) as `value`";
	$sql = "select {$keys} from weixin_brokennet {$where_str} order by `id` desc";
	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	$txt = '';
	foreach($rows as $row) {
		$txt.= $row['value'] . "\n";
	}
	return $txt;
}
