<?php
namespace cloud\apps\zeropen\sdwan\branch;


function select($data)
{
	global $nidb, $user;

	$result = array(
		'rows'	=> array(),
		'total' => 0,
	);

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	if(!is_supadmin($user->username))
		return $result;

	$where_str = "";
	if(format_and_push($data, 'keyword', $optional, '', 'string', false)) {
		$where_str .= "(d.`name` like ? or b.`keyno` like ?) and ";
		array_push($values, "%" . $optional['keyword'] . "%");
		array_push($values, "%" . $optional['keyword'] . "%");
	}

	$order_map = array(
		"bra_id",
		"ent_id",
		"keyno",
	);

	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($op['dir'])) {
				if(in_array($op['column'], $order_map)) {
					array_push($order, "b.`" . $op['column'] . "` " . ($op['dir']=='desc'?'desc':'asc'));
				}
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by ' . implode(', ', $order);
	else
		$order_by = 'order by b.`ent_id`';

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);

	$sql = "select count(*) as `total` from cloud_platform.sdwan_branch as `b`";
	$sql.= " left join palog.cloud_device as `d`";
	$sql.= " on d.`license_id12` = b.`keyno`";
	$sql.= " $where_str";

	try {
		$sth = $nidb->prepare($sql);

		$sth->execute($values);

		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result['total'] = $rows[0]->total;
	}

	$sql = "select if(d.`sys_name` != '', d.`sys_name`, d.`sys_name2`) as `name`, b.* from cloud_platform.sdwan_branch as `b`";
	$sql.= " left join palog.cloud_device as `d`";
	$sql.= " on d.`license_id12` = b.`keyno`";
	$sql.= " $where_str $order_by limit ? offset ? ";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	foreach($rows as $key => $row) {
		if($row->name)
			$rows[$key]->name = to_utf8($row->name);
	}

	$result['rows'] = $rows;

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}
/*
function add($data)
{
	global $nidb, $user;


	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}


	if(isset($data['keyno']) == false || empty(($data['keyno'] = trim($data['keyno'])))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '设备编号不能为空。');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_]{12,})$/", $data['keyno'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "设备编号格式不正确！");
		return false;
	}
	if(isset($data['ent_id']) == false || empty(($data['ent_id'] = trim($data['ent_id'])))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '企业ID不能为空。');
		return false;
	}

	$frmData = array(
		'keyno'		=> $data['keyno'],
		'ent_id'	=> $data['ent_id'],
	);

	try {
		if(insert_data('cloud_platform`.`sdwan_branch', $frmData) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
		$id = $nidb->lastInsertId();

		$cmd = DATAEYE . " device set license_id12={$data['keyno']} ent_id={$data['ent_id']}";
		exec("{$cmd} > /dev/null 2>&1", $out, $ret);
		if($out)
			return implode(' ', $out);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

    return $id;
}
*/
function add($data)
{
	global $nidb, $user;


	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	if(isset($data['keyno']) == false || empty(($data['keyno'] = trim($data['keyno'])))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '设备编号不能为空。');
		return false;
	}
	if(preg_match("/^([a-zA-Z0-9-_]{12,})$/", $data['keyno'], $match) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, "设备编号格式不正确！");
		return false;
	}
	if(isset($data['ent_id']) == false || (($data['ent_id'] = intval(trim($data['ent_id'])))) < 0 ) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '企业ID不能为空。');
		return false;
	}

	$cmd = DATAEYE . " device set license_id12={$data['keyno']} ent_id={$data['ent_id']}";
	exec("{$cmd} > /dev/null 2>&1", $out, $ret);
	if($out)
		return implode(' ', $out);

    return '';
}

function save($data)
{
	global $nidb, $user;

	return;
	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	$values = array();
	
	if(isset($data['bra_id']) == false || empty(($bra_id = trim($data['bra_id'])))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '分支ID不能为空。');
		return false;
	}
	$bra_id = intval($bra_id);
	if($bra_id <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '指定分支不正确。');
		return false;
	}
	if(isset($data['keyno'])) {
		if(empty(($data['keyno'] = trim($data['keyno'])))) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '企业名称不能为空。');
			return false;
		}
		$values['keyno'] = $data['keyno'];
	}

	if(isset($data['ent_id'])) {
		if(empty(($data['ent_id'] = trim($data['ent_id'])))) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '企业不能为空。');
			return false;
		}

		$data['ent_id'] = intval($data['ent_id']);
		if($data['ent_id'] <= 0) {
			set_errmsg(MSG_LEVEL_ARG, __function__, '指定的企业无效。');
			return false;
		}
		$values['ent_id'] = $data['ent_id'];
	}

	if(count($values) <= 0)
		return 0;

	// 检查对象
	try {
		$sql = "select * from `cloud_platform`.`sdwan_branch`";
		$sql.= " where `bra_id` = {$bra_id}";
		$sth = $nidb->prepare($sql);

		$sth->execute();
		// $cnt = $sth->rowCount();
		$row = $sth->fetch(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的分支不存在。');
		return false;
	}

	$where = array(
		'bra_id'	=> $bra_id,
	);

	try {
		if(update_data('cloud_platform`.`sdwan_branch', $values, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}

function del($data)
{
	global $nidb, $user;


	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}

	if(isset($data['bra_id']) == false || empty(($bra_id = trim($data['bra_id'])))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请选择要删除的分支。');
		return false;
	}
	$bra_id = intval($bra_id);
	if($bra_id <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '指定的分支不正确。');
		return false;
	}

	// 检查对象
	try {
		$sql = "select * from `cloud_platform`.`sdwan_branch`";
		$sql.= " where `bra_id` = {$bra_id}";
		$sth = $nidb->prepare($sql);

		$sth->execute();
		// $cnt = $sth->rowCount();
		$row = $sth->fetch(\PDO::FETCH_ASSOC);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(!$row) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '指定的分支不存在。');
		return false;
	}

	try {
		$sql = "delete from `cloud_platform`.`sdwan_branch_iwan` where `bra_id` = {$bra_id}";
		$sth = $nidb->prepare($sql);
		$ret = $sth->execute();

		$sql = "delete from `cloud_platform`.`sdwan_branch` where `bra_id` = {$bra_id}";
		$sth = $nidb->prepare($sql);
		$ret = $sth->execute();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return true;
}
