<?php
namespace cloud\apps\system;


defined('PANALOGEYE') or define ('PANALOGEYE', '/usr/logd/bin/panalogeye');

function boottime()
{
	exec("/sbin/sysctl -n kern.boottime | cut -d',' -f1 | cut -d' ' -f4", $out, $ret);
	if($ret) {
		set_errmsg(MSG_LEVEL_DEF, __function__, $out);
		return false;
	}

	return (int)$out[0];
}

function cpu($data)
{
//		"cpulist"	=> 0,
	$cpu = array(
		"cpunum"	=> 0,
		"cpurate"	=> 0,
		"memrate"	=> 0,
		"physmemM"	=> 0,
		"run_invm"	=> 0,
	);

	exec(DATAEYE . " cpu stat", $out, $ret);
	if($ret == 0) {
		foreach($out as $val) {
			$val = str_replace(array("\n","\r\n"), '', $val);
			list($k, $v) = explode('=', trim($val));
			if(isset($cpu[$k]))
				$cpu[$k] = $v;
		}
	}
	unset($out);

	$json = array(
		'ncpu'	=> $cpu['cpunum'],
		'cpu'	=> $cpu['cpurate'],
		'totalmem'	=> intval($cpu['physmemM'] / 1024 * 10) / 10,
		'mem'	=> $cpu['memrate'],
		'invm'	=> $cpu['run_invm'],
		'hard'	=> 0,
		'hsize'	=> 0,
	);
	
	$total = 0;
	$tused = 0;
	exec("df -h | awk '$1 ~ /^\//{print $2\" \"$5}'", $out, $ret);
	if($ret == 0) {
		foreach($out as $val) {
			list($size, $used) = explode(' ', $val);
			
			// total size
			if(strpos($size, 'T') !== false)
				$size = intval($size) * 1000000;
			else
			if(strpos($size, 'G') !== false)
				$size = $size * 1000;
			else
			if(strpos($size, 'M') !== false)
				$size = intval($size);
			else
				$size = intval($size) / 1000;

			$total+= $size;

			// total used
			$tused+= $size * ($used / 100);
		}
	}
	unset($out);

	if($total > 0) {
		$json["hard"] = intval($tused / $total * 100);
		if($total > 1000000) // T
			$json["hsize"] = (intval($total / 100000) / 10) . "T";
		else
		if($total > 1000) // G
			$json["hsize"] = (intval($total / 100) / 10) . "G";
		else
		if($total > 0) // M
			$json["hsize"] = (intval($total * 10) / 10) . "M";
		else
			$json["hsize"] = 0;
	}
	
	return $json;
}


function reboot()
{
	exec("sleep 3 && reboot &", $err, $ret);
	if($ret)
		set_errmsg(MSG_LEVEL_DEF, __function__, implode(' ', $err));

	return $ret;
}

function shutdown()
{
	if(php_uname('s') == 'FreeBSD')
		exec("shutdown -p now 2>&1", $err, $ret);
	else
		exec("shutdown -h now 2>&1", $err, $ret);

	if($ret)
		set_errmsg(MSG_LEVEL_DEF, __function__, implode(' ', $err));

	return $ret;
}
