<?php
define ("ROOT_DIR", dirname(dirname(dirname(__DIR__))));
require_once(ROOT_DIR . '/conf/config.php');
require_once(ROOT_DIR . '/apps/user/lib/login.php');

$nidb->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_WARNING);

// 2020-04-14
$sql = "
CREATE TABLE IF NOT EXISTS cloud_platform.custom_topo (
  `tid` int(11) NOT NULL AUTO_INCREMENT COMMENT '拓扑图ID',
  `founder` char(32) NOT NULL DEFAULT '' COMMENT '创建始人',
  `name` char(64) NOT NULL DEFAULT '' COMMENT '拓扑图名称',
  `extend` longtext NOT NULL COMMENT '扩展配置，JSON',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`tid`)
) ENGINE=MyISAM default charset=utf8;
";
$nidb->query($sql);

$sql = "
CREATE TABLE IF NOT EXISTS cloud_platform.custom_topo_nodes (
  `nid` int(11) NOT NULL AUTO_INCREMENT COMMENT '节点ID',
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT '归属拓扑图ID',
  `name` char(64) NOT NULL DEFAULT '' COMMENT '节点名称',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT '节点类型',
  `bddevtype` int(11) NOT NULL DEFAULT '0' COMMENT '绑定设备类型：0：未绑定，1：网关PA设备',
  `bddevid` char(32) NOT NULL DEFAULT '' COMMENT '绑定设备的唯一ID',
  `incnt` int(11) NOT NULL DEFAULT '0' COMMENT '接内的IO数',
  `outcnt` int(11) NOT NULL DEFAULT '0' COMMENT '接外的IO数',
  `extend` longtext NOT NULL COMMENT '扩展配置，JSON',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`nid`)
) ENGINE=MyISAM default charset=utf8;
";
$nidb->query($sql);

$sql = "
CREATE TABLE IF NOT EXISTS cloud_platform.custom_topo_group (
  `gid` int(11) NOT NULL AUTO_INCREMENT COMMENT '组ID',
  `name` char(32) NOT NULL DEFAULT '' COMMENT '组名称',
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT '归属拓扑图ID',
  `index` int(11) NOT NULL DEFAULT '0' COMMENT '组排序序号',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT '成员数量',
  `extend` longtext NOT NULL COMMENT '扩展配置，JSON',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`gid`)
) ENGINE=MyISAM default charset=utf8;
";
$nidb->query($sql);

$sql = "
CREATE TABLE IF NOT EXISTS cloud_platform.custom_topo_group_child (
  `gid` int(11) NOT NULL DEFAULT '0' COMMENT '组名称',
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT '归属拓扑图ID',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT '节点ID',
  PRIMARY KEY (`gid`,`tid`,`nid`)
) ENGINE=MyISAM default charset=utf8;
";
$nidb->query($sql);

$sql = "
CREATE TABLE IF NOT EXISTS cloud_platform.custom_topo_nodes_links (
  `tid` int(11) NOT NULL DEFAULT '0' COMMENT '归属拓扑图',
  `src` int(11) NOT NULL DEFAULT '0' COMMENT '原节点',
  `dst` int(11) NOT NULL DEFAULT '0' COMMENT '目标节点',
  `srcio` char(16) NOT NULL DEFAULT '' COMMENT '原IO名称',
  `dstio` char(16) NOT NULL DEFAULT '' COMMENT '目标IO名称',
  PRIMARY KEY (`src`, `dst`, `srcio`,`dstio`)
) ENGINE=MyISAM default charset=utf8;
";
//  `type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '关系类型',
$nidb->query($sql);


$nidb->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);  


// 2021-04-22 自动关联图标目录
$path = LOGDATA_DIR . "/cloud_image";
$img_dir = ROOT_DIR . "/assets/img/topo";

// 安装默认的图标
if(is_dir(__DIR__ . '/image')) {
	if(!is_dir($path)) 
		exec("mkdir -p {$path} > /dev/null 2>&1", $err, $ret);

	if ($dh = opendir(__DIR__ . '/image')){
		while (($file = readdir($dh)) !== false) {
			if($file != "." && $file != "..") {
				$dstfile = "{$path}/{$file}";
				if (!is_file($dstfile)) 
					copy(__DIR__ . "/image/{$file}", $dstfile);
			}
		}
		closedir($dh);
	}
}
if(!is_link($img_dir)) {
	exec("rm -rf {$img_dir} > /dev/null 2>&1", $err, $ret);
	unset($err);
	exec("ln -s {$path} {$img_dir} > /dev/null 2>&1", $err, $ret);
}
