<?php
namespace cloud\apps\webssh;


function add($data)
{
	$cmdarg = "cmdarg=-p\n";
	$cmdarg.= "cmdarg={$data['target_port']}\n";
	$cmdarg.= "cmdarg={$data['target_host']}\n";
	$cmdarg.= "user={$data['user']}\n";
	$cmdarg.= "titile=\"{$data['titile']}\"\n";
	$cmdarg.= "name={$data['name']}\n";
	$cmdarg.= "serialno={$data['serialno']}\n";
	$cmdarg.= "target_port={$data['target_port']}\n";
	$cmdarg.= "createtm={$data['createtm']}\n";
	$cmdarg.= "expired={$data['expired']}\n";
	$openid_dir = LOGDATA_DIR . "/App/webssh/openid";
	if(!is_dir($openid_dir)) 
		exec("mkdir -p {$openid_dir} 2>&1", $out, $ret);
	file_put_contents("{$openid_dir}/{$data['openid']}.dat", $cmdarg);
	exec("/usr/logd/App/webssh/appctrl start 2>&1", $out, $ret);

	return $ret;
}

function getport()
{
	$port = 18890;
	$fconf = '/usr/logdata/App/webssh/config.conf';
	if(file_exists($fconf)) {
		$fp = fopen($fconf, 'r');
		if($fp) {
			while(!feof($fp)) {
				if(($buf = fgets($fp)) === false)
					break;
				$buf = trim($buf);
				if($buf[0] == 'W' && $buf[1] == 'S'
				&& $buf[2] == 'P' && $buf[3] == 'O'
				&& $buf[4] == 'R' && $buf[5] == 'T'
				&& $buf[6] == '=') {
					$wsport = intval(substr($buf, 7));
					if($wsport <= 0)
						$port = $wsport;
					break;
				}
			}

			fclose($fp);
		}
		
	}

	return $port;
}

function make_openid()
{
	global $nidb, $user;
	
	if(!is_supadmin($user->username)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '您的权限不足。');
		return false;
	}
	
	// if ssh then create webssh openid
	if(!file_exists('/usr/logd/App/webssh/appctrl')) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'webssh APP未安装。');
		return false;
	}

	$openid = 'ME-' . md5('SSH_' . $user->username);

	$sshport = get_sshport();
	$now = time();
	add(array(
		'openid'	=> $openid,
		'target_port'=> $sshport,
		'target_host'=> "127.0.0.1",
		'user'		=> $user->username,
		'titile'	=> "云平台终端",
		'name'		=> "云平台终端",
		'serialno'	=> "云平台终端",
		'createtm'	=> $now,
		'expired'	=> $now + 180
	));
	
	$result = array(
		'openid'		=> $openid,
		'webssh_port'	=> 0 // getport(),
	);

	return $result;
}
