<?php
define ("ROOT_DIR", dirname(dirname(dirname(__DIR__))));
require_once(ROOT_DIR . '/conf/config.php');
require_once(ROOT_DIR . '/apps/user/lib/login.php');


$nidb->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_WARNING);

// 创建SD-WAN服务端表
$sql = "create table if not exists cloud_platform.zeropen_device (";
$sql.= "`zpd_id` bigint NOT NULL auto_increment primary key COMMENT '零配置ID' ,";
$sql.= "`wkpid` bigint NOT NULL DEFAULT 0 COMMENT '项目ID' ,";
$sql.= "`disabled` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '0：正常，自动同步配置，1：禁用，不自动同步配置；100：删除' ,";
$sql.= "`name` char(32) NOT NULL DEFAULT '' COMMENT '单元名称' ,";
$sql.= "`matchkeyno` char(16) NOT NULL DEFAULT '' COMMENT '自动匹配设备的12编号' ,";
$sql.= "`device` char(16) NOT NULL DEFAULT '' COMMENT '绑定设备的12编号' ,";
$sql.= "`cookie` char(86) NOT NULL DEFAULT '' COMMENT '绑定设备的86编号' ,";
$sql.= "`token` char(47) NOT NULL DEFAULT '' COMMENT '47位token编码' ,";
$sql.= "`netif` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT '物理网络接口数' ,";
$sql.= "`lan` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT '虚拟LAN接口数' ,";
$sql.= "`wan` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT '虚拟WAN接口数' ,";
$sql.= "`err` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT '错误数' ,";
$sql.= "`msg` varchar(255) NOT NULL DEFAULT '' COMMENT '消息' ,";
$sql.= "`locked` tinyint NOT NULL DEFAULT 0 COMMENT '0：未锁定，否则已锁定，锁定后此配置无法再匹配设备' ,";
$sql.= "`sync` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '同步配置的标记：0不同步，1PA配置，2授权，4系统名称，8运维脚本，16批量脚本' ,";
$sql.= "`lasttm` bigint NOT NULL DEFAULT 0 COMMENT '最后同步配置时间' ,";
$sql.= "`matchtm` bigint NOT NULL DEFAULT 0 COMMENT '最后匹配时间' ,";
$sql.= "`mtime` bigint NOT NULL DEFAULT 0 COMMENT '修改时间' ,";
$sql.= "`ctime` bigint NOT NULL DEFAULT 0 COMMENT '创建时间'";
$sql.= ") engine=myisam default charset=utf8";
$nidb->query($sql);

/*
// 创建服务端的线路绑定表
$sql = "create table if not exists cloud_platform.zeropen_netif (";
$sql.= "`if_id` bigint NOT NULL auto_increment primary key COMMENT '网卡ID' ,";
$sql.= "`zpd_id` bigint NOT NULL DEFAULT 0 COMMENT '零配置ID' ,";
$sql.= "`ifname` char(32) NOT NULL DEFAULT '' COMMENT '物理网卡' ,";
$sql.= "`mode` char(48) NOT NULL DEFAULT '' COMMENT '接入模式' ,";
$sql.= "`zone` char(48) NOT NULL DEFAULT '' COMMENT '接入位置' ,";
$sql.= "`peer` char(16) NOT NULL DEFAULT '' COMMENT '对端接口' ,";
$sql.= "`lagroup` char(64) NOT NULL DEFAULT '' COMMENT '链路捆绑' ,";
$sql.= "`ifspeed` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '工作模式' ,";
$sql.= "`note` char(255) NOT NULL DEFAULT '' COMMENT '备注' ,";
$sql.= "`mtime` bigint NOT NULL DEFAULT 0 COMMENT '修改时间' ,";
$sql.= "`ctime` bigint NOT NULL DEFAULT 0 COMMENT '创建时间'";
$sql.= ") engine=myisam default charset=utf8";
$nidb->query($sql);


// 创建SD-WAN客户端表
$sql = "create table if not exists cloud_platform.zeropen_lan (";
$sql.= "`lan_id` bigint NOT NULL auto_increment primary key COMMENT 'LAN ID' ,";
$sql.= "`zpd_id` bigint NOT NULL DEFAULT 0 COMMENT '零配置ID' ,";
$sql.= "`disabled` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '0：正常，1：禁用；100：删除' ,";
$sql.= "`if_id` bigint NOT NULL DEFAULT 0 COMMENT '所在网卡，网卡ID' ,";
$sql.= "`name` char(32) NOT NULL DEFAULT '' COMMENT '线路名称' ,";
$sql.= "`ifaddr` char(16) NOT NULL DEFAULT '' COMMENT 'IP地址' ,";
$sql.= "`netmask` char(16) NOT NULL DEFAULT '' COMMENT '网络掩码' ,";
$sql.= "`vlan` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT 'VLAN-Tag' ,";
$sql.= "`mtu` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT 'MTU' ,";
$sql.= "`clonemac` char(16) NOT NULL DEFAULT '' COMMENT '克隆MAC' ,";
$sql.= "`mode` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '初始状态' ,";
$sql.= "`standby` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '唤醒线路, 0: 工作状态; 1: 待机设置' ,";
$sql.= "`mtime` bigint NOT NULL DEFAULT 0 COMMENT '修改时间' ,";
$sql.= "`ctime` bigint NOT NULL DEFAULT 0 COMMENT '创建时间'";
$sql.= ") engine=myisam default charset=utf8";
$nidb->query($sql);


// 创建客户端的线路绑定表
$sql = "create table if not exists cloud_platform.zeropen_wan (";
$sql.= "`wan_id` bigint NOT NULL auto_increment primary key COMMENT 'WAN ID' ,";
$sql.= "`zpd_id` bigint NOT NULL DEFAULT 0 COMMENT '零配置ID' ,";
$sql.= "`disabled` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '0：正常，1：禁用；100：删除' ,";
$sql.= "`type` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '线路类型；0：静态IP，static；1：PPPOE，pppoe；2：DHCP，dhcp；3：L2TP，l2tp；4：iWAN，iwan' ,";
$sql.= "`if_id` bigint NOT NULL DEFAULT 0 COMMENT '所在网卡，网卡ID 或 if type > 0 then WAN ID' ,";
$sql.= "`name` char(32) NOT NULL DEFAULT '' COMMENT '线路名称' ,";
$sql.= "`vlanin` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT '内层VLAN(L2TP/iWAN 不需要)' ,";
$sql.= "`vlanout` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT '外层VLAN(L2TP/iWAN 不需要)' ,";
$sql.= "`mtu` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT 'MTU' ,";
$sql.= "`clonemac` char(16) NOT NULL DEFAULT '' COMMENT '克隆MAC(L2TP/iWAN 不需要)' ,";

// 0：静态IP，static；
$sql.= "`pingip` char(32) NOT NULL DEFAULT '' COMMENT '心跳服务器(心跳1,心跳2)' ,";
$sql.= "`ifaddr` char(64) NOT NULL DEFAULT '' COMMENT 'IP地址/ 服务器IP(L2TP/iWAN)' ,";
$sql.= "`gwpxy` char(16) NOT NULL DEFAULT '' COMMENT '网关类型；0：正常网关，1：互联地址' ,";
$sql.= "`proxygw` char(16) NOT NULL DEFAULT '' COMMENT '网关地址' ,";
$sql.= "`proxydns` char(16) NOT NULL DEFAULT '' COMMENT 'DNS服务器：0.0.0.0' ,";

// 1：PPPOE，pppoe；3：L2TP，l2tp；4：iWAN，iwan
$sql.= "`acct` char(32) NOT NULL DEFAULT '' COMMENT 'PPPOE/L2TP/iWAN账号' ,";
$sql.= "`pass` char(16) NOT NULL DEFAULT '' COMMENT 'PPPOE/L2TP/iWAN密码' ,";
$sql.= "`waitime` char(16) NOT NULL DEFAULT '' COMMENT '重拨等待时间' ,";

// 2：DHCP，dhcp；

// 3：L2TP，l2tp；4：iWAN，iwan
$sql.= "`svrport` char(32) NOT NULL DEFAULT '' COMMENT '服务器端口, 默认：1701' ,";

$sql.= "`mtime` bigint NOT NULL DEFAULT 0 COMMENT '修改时间' ,";
$sql.= "`ctime` bigint NOT NULL DEFAULT 0 COMMENT '创建时间'";
$sql.= ") engine=myisam default charset=utf8";
$nidb->query($sql);


// 创建SD-WAN连接关系表
$sql = "create table if not exists cloud_platform.zeropen_route (";
$sql.= "`route_id` bigint NOT NULL auto_increment primary key COMMENT '路由策略ID' ,";
$sql.= "`zpd_id` bigint NOT NULL DEFAULT 0 COMMENT '零配置ID' ,";
$sql.= "`disabled` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '0：正常，1：禁用；100：删除' ,";

$sql.= "`inifname` bigint NOT NULL DEFAULT 0 COMMENT '源接口' ,";
$sql.= "`pool` bigint NOT NULL DEFAULT 0 COMMENT '用户组/地址池' ,";
$sql.= "`vlan` char(32) NOT NULL DEFAULT '' COMMENT 'VLAN：10或10-20或10-20/10-20,0或0-0或不填表示任意VLAN' ,";
$sql.= "`ttl` smallint UNSIGNED NOT NULL DEFAULT 0 COMMENT 'TTL：10或10-20,不填表示任意TTL' ,";
$sql.= "`srctype` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '源地址类型：0：any；1：net（xxx.xxx.xxx.xxx/nn）；range：（n.n.n.n-m.m.m.m）；table：（IP群组）' ,";
$sql.= "`srctval` char(32) NOT NULL DEFAULT '' COMMENT 'srctype的源地址值' ,";
$sql.= "`dstype` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '目标地址类型：0：any；1：net（xxx.xxx.xxx.xxx/nn）；range：（n.n.n.n-m.m.m.m）；table：（IP群组）' ,";
$sql.= "`dstval` char(32) NOT NULL DEFAULT '' COMMENT 'srctype的目标地址值' ,";

$sql.= "`proto` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '传输协议' ,";
$sql.= "`appname` char(32) NOT NULL DEFAULT '' COMMENT '应用协议' ,";
$sql.= "`dscp` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '应用协议' ,";
$sql.= "`usrtype` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '用户类型；0：任意；1：代拨用户；2：非代拨用户' ,";

$sql.= "`action` int UNSIGNED NOT NULL DEFAULT 0 COMMENT '执行动作；0：NAT；1：CGNAT；2：路由；3：代拨用户' ,";

// 0：NAT；1：CGNAT；
$sql.= "`newdstip` char(16) NOT NULL DEFAULT '' COMMENT 'DNAT地址' ,";

// 0：NAT；1：CGNAT；2：路由
$sql.= "`pxtype` tinyint UNSIGNED NOT NULL DEFAULT 0 COMMENT '动作的代理类型：0：网上；1：LAN；2：WAN；3：DHCP；' ,";
$sql.= "`proxy` bigint NOT NULL DEFAULT 0 COMMENT 'DNAT线路/路由' ,";
$sql.= "`nexthop` char(16) NOT NULL DEFAULT '' COMMENT '下一跳' ,";

$sql.= "`note` char(255) NOT NULL DEFAULT '' COMMENT '备注' ,";
$sql.= "`mtime` bigint NOT NULL DEFAULT 0 COMMENT '修改时间' ,";
$sql.= "`ctime` bigint NOT NULL DEFAULT 0 COMMENT '创建时间'";
$sql.= ") engine=myisam default charset=utf8";
$nidb->query($sql);
*/

$nidb->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);  

