<?php
namespace cloud\apps\zeropen\logger\device;

defined('OPSZEROPEN_DIR') or define('OPSZEROPEN_DIR', OPSSVC_DIR . "/zeropen");
defined('OPSZEROPEN_TOKEN_DIR') or define('OPSZEROPEN_TOKEN_DIR', OPSTOKEN_DIR . "/zeropen");


function select($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/logger";
	if(is_dir($dir))
		$files = lsdir_file($dir);
	else
		$files = array();

	return $files;
}

function del($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/logger";
	
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}

	$file = "{$dir}/{$data['name']}";
	if(file_exists($file)) 
		unlink($file);

	return true;
}

function get($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/logger";
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}

	$file = "{$dir}/{$data['name']}";
	if(file_exists($file)) 
		$text = file_get_contents($file);
	else
		$text = '';

	if($text === false)
		set_errmsg(MSG_LEVEL_ARG, __function__, '读取数据失败！');

	return $text;
}

function save($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/logger";
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}

	if(isset($data['text']))
		$text = trim($data['text']);
	else
		$text = '';

	if(!is_dir($dir))
		exec("mkdir -p {$dir} 2>&1", $output, $ret);

	$file = "{$dir}/{$data['name']}";
	if(file_put_contents($file, $text) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '保存文件失败！');
		return false;
	}

	return true;
}

