<?php
namespace cloud\apps\zeropen\shellops;

defined('OPSZEROPEN_DIR') or define('OPSZEROPEN_DIR', OPSSVC_DIR . "/zeropen");
defined('OPSZEROPEN_TOKEN_DIR') or define('OPSZEROPEN_TOKEN_DIR', OPSTOKEN_DIR . "/zeropen");


function select($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$files = array('默认的配对运维（无）');
	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops";
	if(is_dir($dir)) {
		$data = lsdir_file($dir);
		if(($index = array_search('默认的配对运维', $data)) !== false){
			$files = array('默认的配对运维');
			array_splice($data, $index, 1);
			$files = array_merge($files, $data);
		}
		else
			$files = array_merge($files, $data);
	}
	
	return $files;
}

function del($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops";
	
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}
	if($data['name'] == '默认的配对运维（无）')
		$data['name'] = '默认的配对运维';

	$file = "{$dir}/{$data['name']}";
	if(file_exists($file)) 
		unlink($file);

	return true;
}

function get($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops";
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}
	if($data['name'] == '默认的配对运维（无）')
		$data['name'] = '默认的配对运维';
	
	$file = "{$dir}/{$data['name']}";
	if(file_exists($file)) 
		$text = file_get_contents($file);
	else
		$text = '';

	if($text === false)
		set_errmsg(MSG_LEVEL_ARG, __function__, '读取数据失败！');

	return $text;
}

function save($data)
{
	global $nidb;


	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops";
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}
	
	if($data['name'] == '默认的配对运维（无）')
		$data['name'] = '默认的配对运维';
	
	if(isset($data['text']))
		$text = trim($data['text']);
	else
		$text = '';

	if(!is_dir($dir))
		exec("mkdir -p {$dir} 2>&1", $output, $ret);

	$file = "{$dir}/{$data['name']}";
	if(file_put_contents($file, $text) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '保存文件失败！');
		return false;
	}

	return true;
}

function shellexec($data)
{
	global $nidb;

	save($data); 

	if(isset($data['zpd_id']) == false || ($zpd_id = intval($data['zpd_id'])) <= 0) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '请指定要操作的对象。');
		return false;
	}
	set_errmsg(MSG_LEVEL_ARG, __function__, '');

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops";
	if(isset($data['name']) == false || empty($data['name'] = trim($data['name']))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '名称不能为空！');
		return false;
	}
	if($data['name'] == '默认的配对运维（无）')
		$data['name'] = '默认的配对运维';
	
	$file = "{$dir}/{$data['name']}";
	if(!file_exists($file)) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '找不到此运维。');
		return false;
	}

	$text = file_get_contents($file, $text);
	if($text === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '读取运维失败。');
		return false;
	}
	$text = iconv('utf-8', 'gbk', $text);
	if($text === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '将运维转换成GBK编码时失败。');
		return false;
	}

	$dir = OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops";
	$execdir = "{$dir}/exec";
	if(!is_dir($execdir))
		exec("mkdir -p {$execdir} 2>&1", $output, $ret);

	$now = time();
	$shellname = iconv('utf-8', 'gbk', $data['name']);
	$head = "# opstool: {$shellname}\n";
	$head.= "# opstime: {$now}\n";
	$head.= "# date: " . date('Y-m-d H:i:s', $now) . "\n\n";

	// 如果需要执行配置，需要在 
	// OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops/exec" 目录下
	// 创建 GBK编码的 脚本文件，否则删除。
	if(file_put_contents("{$execdir}/shellops-{$now}", $head . $text) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '保存运维任务时失败。');
		return false;
	}

	// 创建报告文件
	$reportdir = OPSZEROPEN_DIR . "/device/{$zpd_id}/report/shellops";
	if(!is_dir($reportdir)) 
		exec("mkdir -p {$reportdir} 2>&1", $output, $ret);

	$text = "【{$data['name']}】运维任务于 " . date('Y-m-d H:i:s', $now) . " 创建，正在等待客户端执行...\n\n";
	if(!($fp = fopen("{$reportdir}/{$data['name']}", 'w'))) {
		set_errmsg(MSG_LEVEL_ARG, __function__, '创建运维的任务日志失败。');
		return false;
	}
	fwrite($fp, $text);
	fclose($fp);

	// 创建同步标记
	$syncdir = OPSZEROPEN_DIR . "/device/{$zpd_id}/sync";
	if(!is_dir($syncdir))
		exec("mkdir -p {$syncdir} 2>&1", $output, $ret);
	file_put_contents("{$syncdir}/shellops-one-run", "shellops-{$now} {$data['name']}");

	// 通知客户端更新
	try {
		$sql = "select `device` from `cloud_platform`.`zeropen_device`";
		$sql.= " where `token` != '' and `zpd_id` = ?";
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $zpd_id, \PDO::PARAM_INT);
		if($sth->execute() && ($row = $sth->fetch(\PDO::FETCH_ASSOC))) {
			$cmd = DATAEYE . " device set license_id12={$row['device']} task_signal=1";
			exec("{$cmd} > /dev/null 2>&1");
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	return $data['name'];
}
