<?php
/*
 * 该文件来自 task.php?r=opssvc&name=zeropen&act=fetch
 *				> apps/devops/task-api/opssvc.php 的请求回调
 * 用于响应客户端的任务请求，更新客户端执行任务的状态。
 *
 * 已解析的参数有：
 * $keyno 12位授权编号 
 * $name 服务名称 
 * $act 服务功能 
 * $token 客户端唯一编码，服务令牌 token
 * $_REQUEST 附加数据，可从这里取
 *
 */

if(empty($token)) exit;

defined('OPSZEROPEN_DIR') or define('OPSZEROPEN_DIR', OPSSVC_DIR . "/zeropen");
defined('OPSZEROPEN_TOKEN_DIR') or define('OPSZEROPEN_TOKEN_DIR', OPSTOKEN_DIR . "/zeropen");

$tokendir = OPSZEROPEN_TOKEN_DIR . "/{$token}";
if(!file_exists($tokendir))
	exit;

// 检查任务是否已经上限
if(maxdown_check('zeropen') <= 0)
	exit;

// 设置 URL 路径 $url_path
$http = "http";
if(isset($_SERVER['REQUEST_SCHEME'])
&& intval($_SERVER['REQUEST_SCHEME']))
	$http = $_SERVER['REQUEST_SCHEME'];
else
if(isset($_SERVER['HTTP_UPGRADE_INSECURE_REQUESTS'])
	&& intval($_SERVER['HTTP_UPGRADE_INSECURE_REQUESTS'])) {
		$http = "https";
}
else
if(isset($_SERVER['SERVER_PORT'])
	&& intval($_SERVER['SERVER_PORT']) == 443) {
		$http = "https";
}
$url_path = $http . "://" . $_SERVER['HTTP_HOST'];

// 检查是否有内容需要更新
$content = '';

// 检查系统名称是否需要同步
$syncdir = "{$tokendir}/sync";
$fupdate = "{$syncdir}/sysname.conf";
if(file_exists($fupdate)) {
	$sysname = file_get_contents("{$tokendir}/sysname.conf");
	if($sysname)
		$content.= "sysname={$sysname}\n";
	unlink($fupdate);
}

// 检查系统配置是否需要同步
$fupdate = "{$syncdir}/panabit.conf";
if(file_exists($fupdate)) {
	$content.= "confurl={$url_path}/devops/token/zeropen/{$token}/panabit.conf\n";
	unlink($fupdate);
}

// 检查系统授权是否需要同步
$fupdate = "{$syncdir}/license.pac";
if(file_exists($fupdate)) {
	$content.= "licurl={$url_path}/devops/token/zeropen/{$token}/license.pac\n";
	unlink($fupdate);
}

// 检查是否有运维脚本需要执行
$fupdate = "{$syncdir}/shellops-default-run";
if(file_exists($fupdate)) {
	$shellname = file_get_contents($fupdate);
	if($shellname) {
		$node = explode(' ', $shellname);
		if(count($node) == 2) {
			$fshell = "{$tokendir}/shellops/exec/{$node[0]}";
			if(file_exists($fshell))
				$content.= "shellurl={$url_path}/devops/token/zeropen/{$token}/shellops/exec/{$node[0]}\n";
		}
	}
	unlink($fupdate);
}


// 检查是否有运维脚本需要执行
$fupdate = "{$syncdir}/shellops-one-run";
if(file_exists($fupdate)) {
	$shellname = file_get_contents($fupdate);
	if($shellname) {
		$node = explode(' ', $shellname);
		if(count($node) == 2) {
			$fshell = "{$tokendir}/shellops/exec/{$node[0]}";
			if(file_exists($fshell))
				$content.= "shellurl={$url_path}/devops/token/zeropen/{$token}/shellops/exec/{$node[0]}\n";
		}
	}
	unlink($fupdate);
}

if($content != '') {
	$fpath = OPSWEB_DIR . "/processes/zeropen/{$token}";
	file_put_contents($fpath, time());
	echo $content;
}