<?php
/*
 * 该文件来自 task.php?r=opssvc&name=zreopen&act=token 
 *  			> apps/devops/task-api/opssvc.php 的请求回调
 * 用于响应客户端的任务请求：
 * 	1) 给新客户端分配 token，之后客户端可以根据token更新配置。
 * 	2) 解除token与设备的关系，会告之用户删除关系。
 *
 * 已解析的参数有：
 * $keyno 12位授权编号 
 * $token 客户端唯一编码，服务令牌 token
 * $name 服务名称 
 * $act 服务功能 
 * $_REQUEST 附加数据，可从这里取
 *
 */


function shellexec($token)
{
	global $nidb;


	$name = '默认的配对运维';
	$dir = OPSZEROPEN_TOKEN_DIR . "/{$token}";
	$file = "{$dir}/shellops/{$name}";
	if(!file_exists($file)) {
		$file = OPSTOOL_DIR . "/shellops/param/{$name}";
		if(!file_exists($file))
			return false;
	}

	$text = file_get_contents($file, $text);
	if($text === false) return false;
	$text = iconv('utf-8', 'gbk', $text);
	if($text === false) return false;

	$execdir = "{$dir}/shellops/exec";
	if(!is_dir($execdir))
		exec("mkdir -p {$execdir} 2>&1", $output, $ret);

	$shellname = iconv('utf-8', 'gbk', $name);
	$head = "# opstool: {$shellname}\n";
	$head.= "# opstime: {$now}\n";
	$head.= "# date: " . date('Y-m-d H:i:s', $now) . "\n\n";

	// 如果需要执行配置，需要在 
	// OPSZEROPEN_DIR . "/device/{$zpd_id}/shellops/exec" 目录下
	// 创建 GBK编码的 脚本文件，否则删除。
	if(file_put_contents("{$execdir}/shellops-{$now}", $head . $text) === false) 
		return false;

	// 创建报告文件
	$reportdir = "{$dir}/report/shellops";
	if(!is_dir($reportdir)) 
		exec("mkdir -p {$reportdir} 2>&1", $output, $ret);

	$text = "【{$name}】运维任务于 " . date('Y-m-d H:i:s', $now) . " 创建，正在等待客户端执行...\n\n";
	if(!($fp = fopen("{$reportdir}/{$name}", 'w'))) 
		return false;
	fwrite($fp, $text);
	fclose($fp);

	// 创建同步标记
	$syncdir = OPSZEROPEN_TOKEN_DIR . "/{$token}/sync";
	if(!is_dir($syncdir))
		exec("mkdir -p {$syncdir} 2>&1", $output, $ret);
	file_put_contents("{$syncdir}/shellops-default-run", "shellops-{$now} {$name}");

	// 数据库加载
	require_once(ROOT_DIR . '/ni-core/class/ni_db.php');
	require_once(ROOT_DIR . '/conf/db.php');

	// 通知客户端更新
	try {
		$sql = "select `device` from `cloud_platform`.`zeropen_device`";
		$sql.= " where `token` = ?";

		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $token, \PDO::PARAM_STR);
		if($sth->execute() && ($row = $sth->fetch(\PDO::FETCH_ASSOC))) {
			$cmd = DATAEYE . " device set license_id12={$row['device']} task_signal=1";
			exec("{$cmd} > /dev/null 2>&1");
		}
		else
			return false;
	}
	catch (\NiDBException $e) {
		return false;
	}

	return true;
}

function lsdir_file($path)
{
	$ret = array();

	if (is_dir($path) && ($dh = opendir($path))){
		while (($file = readdir($dh)) !== false) {
			if($file != "." && $file != "..") {
				$device_file = $path . '/' . $file;
				if (is_file($device_file)) {
					if (is_dir(OPSZEROPEN_DIR . "/device/{$file}")) {
						var_dump(file_exists(OPSZEROPEN_DIR . "/device/{$file}/locked.dat"),
						file_exists(OPSZEROPEN_DIR . "/device/{$file}/token.dat")
						);
						if(!file_exists(OPSZEROPEN_DIR . "/device/{$file}/locked.dat")
						&&file_exists(OPSZEROPEN_DIR . "/device/{$file}/token.dat")) {
							array_push($ret, $file);
						}
					}
					else
						exec("rm -f {$device_file} 2>&1", $output, $ret);
				}
			}
		}
		closedir($dh);
	}

	return $ret;
}

function match_lock($zpd_id)
{
	global $nidb, $user;
	
	
	$token = file_get_contents(OPSZEROPEN_DIR . "/device/{$zpd_id}/token.dat");
	if(!$token) 
		exit;
	
	$now = time();
	
	// 数据库加载
	require_once(ROOT_DIR . '/ni-core/class/ni_db.php');
	require_once(ROOT_DIR . '/conf/db.php');

	$sql = "update cloud_platform.zeropen_device";
	$sql.= " set `matchtm` = {$now}, `locked` = 1";
	$sql.= " where `zpd_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		$sth->bindParam(1, $zpd_id, PDO::PARAM_INT);
		if(!$sth->execute()) {
			echo "ERR SQL EXECUTE";
			exit;
		}
	}
	catch (NiDBException $e) {
		echo "ERR SQL";
		exit;
	}

	// 成功，返回 token
	$flock = OPSZEROPEN_DIR . "/device/{$zpd_id}/locked.dat";
	file_put_contents($flock, $now);

	// 更新配对日志
	$loggerdir = OPSZEROPEN_TOKEN_DIR . "/{$token}/logger";
	if(!is_dir($loggerdir))
		exec("mkdir -p {$loggerdir} 2>&1", $output, $ret);

	$freport = "{$loggerdir}/" . date("Y-m-d", $now);
	if(($fp = fopen($freport, 'a'))) {
		fwrite($fp, '[' . date("H:i:s", $now) . "] 设备配对 token: {$token}\n");
		fclose($fp);
	}

	shellexec($token);
	
	echo "DATA token={$token}\n";
	exit;
}

if(isset($_REQUEST['cookie']) == false || empty($cookie = trim($_REQUEST['cookie'])))
	exit;
if(preg_match("/^([a-zA-Z0-9-_]{83})$/", $cookie, $match) == false)
	exit;

defined('OPSSVC_DIR') or exit;
defined('OPSZEROPEN_DIR') or define('OPSZEROPEN_DIR', OPSSVC_DIR . "/zeropen");
defined('OPSZEROPEN_TOKEN_DIR') or define('OPSZEROPEN_TOKEN_DIR', OPSTOKEN_DIR . "/zeropen");


$cookiedir = OPSZEROPEN_DIR . "/cookie";
if($token == '') {
	$files = lsdir_file("{$cookiedir}/{$cookie}");

	$cnt = 0;
	$lastid = 0;

	foreach($files as $zpd_id) {
		// 判断此文件的作用是 解决如果同一个硬件编号有多个用户的授权12位编号
		// 时，可以自动匹配。
		// 解决一个硬件编号，有多个用户的问题。
		$fmatch = OPSZEROPEN_DIR . "/device/{$zpd_id}/license.matchkeyno";
		if(file_exists($fmatch)) {
			if($keyno === file_get_contents($fmatch)) {
				match_lock($zpd_id);
				exit;
			}
		}
		else {
			$lastid = $zpd_id;
			$cnt++;
		}
	}

	if($lastid && $cnt === 1)
		match_lock($lastid);
	else
		echo "NOT FOUND";
	exit;
}

$tokenfile = OPSZEROPEN_TOKEN_DIR . "/{$token}";
if(!file_exists($tokenfile))
	echo "REMOVE";
