<?php
/*********************************************************
 * 日期：2021-06-07
 * 功能：清除隧道使用有效期过期的会话
 * 限制：只能后台命令执行
 *********************************************************
 */
if(isset($argc) == false) exit;
define('ROOT_DIR', '/usr/logd/www/cloud');

require_once(ROOT_DIR . '/ni-core/class/ni_db.php');
require_once(ROOT_DIR . '/conf/db.php');

function scan_tunnel()
{
	global $nidb;


	$ids = array();
	$now = time();
	$sql = "select o.`pid` from cloud_platform.tunnel_online as `o`";
	$sql.= " left join cloud_platform.tunnel_user as `u`";
	$sql.= " on `o`.`user` = `u`.`user` and `o`.`tp_id` = `u`.`tp_id`";
	$sql.= " where o.`pid` > 0 and u.`expire_time` > 0 and u.`expire_time` < {$now}";

	try {
		$sth = $nidb->prepare($sql);
		$ret = $sth->execute();
		if($ret) {
			$rows = $sth->fetchAll(\PDO::FETCH_ASSOC);
			foreach($rows as $val) {

				// 断开用户
				$cmd = "kill {$val['pid']} > /dev/null 2>&1";
				exec($cmd, $out, $ret);
				unset($out);

				array_push($ids, $val['pid']);

			}
		}
	}
	catch (NiDBException $e) {
		return;
	}

	// 更新关闭状态。
	if(count($ids) > 0) {
		$idstr = '?';
		$idstr .= str_repeat(',?' , count($ids) - 1);

		$sql = "delete from cloud_platform.tunnel_online where `pid` in ({$idstr})";
		$sth = $nidb->prepare($sql);
		$sth->execute($ids);
/*
		$sql = "update cloud_platform.tunnel_online set `pid` = 0 where `expire_time` < {$now} and `pid` in($idstr)";
		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($ids);
		}
		catch (\NiDBException $e) {
			echo "NiDBException: {$sql}\n";
		}
*/
	}
}

scan_tunnel();
