<?php
/*********************************************************
 * 日期：2021-01-09
 * 功能：分发一键断网任务给PA客户端
 * 限制：只能后台命令执行
 *********************************************************
 */
if(isset($argc) == false) exit;
define('ROOT_DIR', '/usr/logd/www/cloud');

define('TIMEZONE_CONF', '/usr/logdata/timezone.conf');
define('API_WXDENY_FILE', '/usr/logdata/api_wxdeny.dat');
define('API_WXDENY_DIR', '/usr/logdata/api_wxdeny');
define('SYNC_TASK2_DIR', '/usr/logdata/devops/web/task2');
define('CLOUD_UUID_FILE', '/etc/uuidgen.conf');
define('CLOUD_LOG_FILE', '/usr/logd/bin/log.conf');

define('CLOUDEYE', '/usr/logd/bin/cloudeye');


$timezone_id = 'PRC';
if (file_exists(TIMEZONE_CONF) && $fp = fopen(TIMEZONE_CONF, "r")) {
	while (!feof($fp)) {
		if(($buf = fgets($fp)) === false)
			break;
		if(empty($buf = trim($buf, "\t\n\r\0\x0B")))
			continue;

		$col = explode('=', $buf, 2);
		if(count($col) != 2)
			continue;
		$key = trim($col[0]);
		$col[1] = trim($col[1]);
		if(strpos($key, ' ') !== false || empty($col[1]))
			continue;

		if($key != 'timezone_id')
			continue;

		$timezone_id = trim($col[1]);
		break;
	}
	fclose($fp);
}
date_default_timezone_set($timezone_id);

function httpPost($url, $data = array(), $verify = true)
{
	$post = '';
	foreach($data as $k => $v) 
		$post .= "&$k=$v";
	
	if($post != '')
		$post = '--data "' . substr($post, 1) . '" ';
	
	$curl = '/usr/logd/bin/curl';
	if(!file_exists($curl))
		$curl = '/usr/local/bin/curl';
	
	if($verify)
		$cmd = $curl . ' -k --connect-timeout 10 --retry-max-time 10 --max-time 10 ' . $post . '"' . $url . '" 2>/dev/null';
	else
		$cmd = $curl . ' --connect-timeout 10 --retry-max-time 10 --max-time 10 ' . $post . '"' . $url . '" 2>/dev/null';

	$fp = popen($cmd, "r");
	$res = '';
	while (!feof($fp)) {
		$buffer = fgets($fp, 4096); 
		$res .= $buffer;
	}
	pclose($fp);
	//return str_replace(PHP_EOL, '', $res);
	return $res;
}

if (file_exists(CLOUD_LOG_FILE) && $fp = fopen(CLOUD_LOG_FILE, "r")) {
	while (!feof($fp)) {
		if(($buf = fgets($fp)) === false)
			break;
		if(empty($buf = trim($buf, "\t\n\r\0\x0B")))
			continue;

		$col = explode('=', $buf, 2);
		if(count($col) != 2)
			continue;
		$key = trim($col[0]);
		if($key == 'denypolicy_enable' && intval($col[1]) != 1)
			return;
	}
	fclose($fp);
}

function is_ipstr($ipstr)
{
	// 0.0.0.0 or 255.255.255.255
	// 0.0.0.0-255.255.255.255
	// 192.168.0.1/24
	$pat = "/^(((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))$/";
	if(preg_match($pat, $ipstr))
		return true;
	$pat = "/^((((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5])))-((((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5])))$/";
	if(preg_match($pat, $ipstr))
		return true;
	$pat = "/^((((1?\d{1,2})|(2[0-4]\d)|(25[0-5]))\.){3}((1?\d{1,2})|(2[0-4]\d)|(25[0-5])))\/(([1-9]?\d)|\d)$/";
	if(preg_match($pat, $ipstr))
		return true;
	return false;
}

require_once(ROOT_DIR . '/ni-core/class/ni_db.php');
require_once(ROOT_DIR . '/conf/db.php');

if(is_dir(ROOT_DIR . '/apps/tunnel'))
	require_once(ROOT_DIR . '/lib/cmd/tunnel_clear.php');

function gettokentask($serialno)
{
//	$key = strtolower($serialno);
	$cmd = CLOUDEYE. " device get devtoken={$serialno}";
	exec($cmd, $out, $ret);
	if($ret != 0)
		return array();

	$ret = array();
	foreach($out as $val) {
		$cols = explode('=', trim($val));
		if(count($cols) != 2)
			continue;
		$ret[$cols[0]] = $cols[1];
	}

	return $ret;
}

function mktaskshell($devid)
{
	
	$shell = "#!/bin/sh

FLOWEYE=/usr/ramdisk/bin/floweye
";
	if($devid >= 0)
		$shell.= '${FLOWEYE} logger config deviceid=' . $devid . "\n";

	$shell.= 'id=`${FLOWEYE} dns listgrp | grep ' . iconv('UTF-8', 'gb2312', '云平台禁止上网域名') . ' | cut -d\' \' -f2`
if [ "${id}" != "" ]; then
	${FLOWEYE} dns dumpgrp ${id} | xargs -I domain ${FLOWEYE} dns remove ${id} domain
fi
id=`${FLOWEYE} dns listgrp | grep ' . iconv('UTF-8', 'gb2312', '云平台放行上网域名') . ' | cut -d\' \' -f2`
if [ "${id}" != "" ]; then
	${FLOWEYE} dns dumpgrp ${id} | xargs -I domain ${FLOWEYE} dns remove ${id} domain
fi
';

	return $shell;
}

function sync_task()
{
	$tasks = array();

	if (is_dir(API_WXDENY_DIR) 
	&& ($dh = opendir(API_WXDENY_DIR))){
		while (($file = readdir($dh)) !== false) {
			if($file != "." && $file != "..") {
				if(isset($tasks[$file]) == false) {
					$ret = gettokentask($file);
					if(isset($ret['token']) == false || $ret['token'] == '')
						continue;
					$tasks[$file] = $ret;
				}
			}
		}
		closedir($dh);
	}

	// 2021-03-15
	// 云堤需求，创建同步任务，1、同步日志设备ID，2、清空 云平台禁止上网域名、云平台放行上网域名 DNS群组
	foreach($tasks as $serialno => $task) {
		$file = API_WXDENY_DIR . '/' . $serialno;
		if(!file_exists($file))
			continue;

		$devid = -1;
		$task2md5 = '';
		$fd = fopen($file, 'r');
		if(!$fd) continue;
		while(!feof($fd)) {
			if(!($line = fgets($fd, 256)))
				continue;
			$txt = trim($line);
			if($txt == '')
				continue;
			$cols = explode('=', $txt);
			if(count($cols) != 2)
				continue;
			if($cols[0] == 'devid')
				$devid = intval($cols[1]);
			else
			if($cols[0] == 'task2md5')
				$task2md5 = $cols[1];
		}
		fclose($fd);

		$contents = mktaskshell($devid);
		$fret = "{$task['taskpath']}/{$task['token']}/result/wxdeny_netoff_clean";
		$fbinsh = "{$task['taskpath']}/{$task['token']}/bin/wxdeny_netoff_clean.tmp";
		file_put_contents($fbinsh, $contents);
		$md5 = md5_file($fbinsh);
		if($task2md5 == $md5) {
			if(file_exists($fret))
				unlink($file);
			unlink($fbinsh);
			continue;
		}
		if(file_exists($fret))
			unlink($fret);
		rename($fbinsh, "{$task['taskpath']}/{$task['token']}/bin/wxdeny_netoff_clean");

		$forder = "{$task['taskpath']}/{$task['token']}/order/wxdeny_netoff_clean";
		file_put_contents($forder, "");

		$contents = "devid={$devid}\n";
		$contents.= "task2md5={$md5}";
		file_put_contents($file, $contents);
	}
}

function scan_wxdeny()
{
	global $nidb;


	$guid = '';
	if(file_exists(CLOUD_UUID_FILE)) {
		$guid = file_get_contents(CLOUD_UUID_FILE);
		if($guid === false)
			$guid = '';
		else
			$guid = trim($guid, " \t\n\r\0\x0B");
	}
	$md5 = md5("{$guid}bugeiniwan");
	if($md5 == "") {
		echo "fail: guid " . CLOUD_UUID_FILE . "\n";
		return;
	}
/* 
string(96) "deny=host host=xx.fff.com device=PN800A0713aH
deny=host host=www.baidu.com2 device=PN800A0713aH
deny=host host=xx.fff.com device=PA800023-33J
"
*/
	// 主动更新下发状态，解决内网云平台不能下发一键断网的问题。
	$url = "https://115.29.138.209/wxcloud/getcmd.php?systype=cloud&guid={$guid}&tag=panabit_deny&md5={$md5}";
	$retd = httpPost($url, array(), true);
	$data = array (
		'ip' => array (
			'allow' => 0,
			'deny' => 0
		),
		'host' => array (
			'allow' => 0,
			'deny' => 0
		)
	);
	$wxmsgdev = array();
	$first = $text = '';
	$other_cmd = array();
	if($retd) {
		$dataX = explode("\n", $retd);
		foreach($dataX as $row){
			$cons = explode(' ', $row);
			$retdata = array();
			foreach($cons as $value) {
				if(empty($value)) continue;
				$nodes = explode('=', $value, 2);
				if(count($nodes) < 2)
					continue;
				$retdata[$nodes[0]] = str_replace(PHP_EOL, '', $nodes[1]);
			}
			
			if(!isset($retdata['device']))
				continue;
			$serialno = $retdata['device'];
			if(preg_match("/^([a-zA-Z0-9-_]{12})$/", $serialno, $match) == false)
				continue;

			$myevent = '';
			$type = '';
			if(isset($retdata['deny']) && isset($retdata[$retdata['deny']])) {
				$type = $retdata['deny'];
				$myevent = $retdata[$type];
				$status = 0;
			}
			if(isset($retdata['allow']) && isset($retdata[$retdata['allow']])) {
				$type = $retdata['allow'];
				$myevent = $retdata[$type];
				$status = 1;
			}

			if($myevent == '')
				continue;

			$sql = "select * from weixin_brokennet";
			$sql.= " where `myevent` = ? and `license_id12` = '{$serialno}'";

			try {
				$sth = $nidb->prepare($sql);
				$sth->bindParam(1, $myevent, \PDO::PARAM_STR);
				$ret = $sth->execute();
				if($ret) {
					$event = $sth->fetch(\PDO::FETCH_ASSOC);
					if(!$event) {
						if(!isset($wxmsgdev[$serialno]))
							$wxmsgdev[$serialno] = 1;
						else
							$wxmsgdev[$serialno]++;

						if(strpos($myevent, "W:") === 0)
							$event = substr($myevent, 2);
						else
							$event = $myevent;

						if(is_ipstr($event)) {
							if($status) {
								$data['ip']['allow']++;
								$text = "allow=ip ip={$myevent} device={$serialno}";
							}
							else {
								$data['ip']['deny']++;
								$text = "deny=ip ip={$myevent} device={$serialno}";
							}
						}
						else {
							if($status) {
								$data['host']['allow']++;
								$text = "allow=host host={$myevent} device={$serialno}";
							}
							else {
								$data['host']['deny']++;
								$text = "deny=host host={$myevent} device={$serialno}";
							}
						}
						
						if($first == "")
							$first = $text;
						array_push($other_cmd, $text);
					}
				}
			}
			catch (NiDBException $e) {
				return;
			}

			// write to weixin_brokennet
			// isupdate = 127 表示需要统计后发微信通知
			$sql = "update weixin_brokennet set `status` = {$status}, `isupdate` = 127";
			$sql.= " where `myevent` = ? and `license_id12` = '{$serialno}'";
			try {
				$sth = $nidb->prepare($sql);
				$sth->bindParam(1, $myevent, \PDO::PARAM_STR);
				$ret = $sth->execute();
			}
			catch (NiDBException $e) {
				echo "NiDBException: {$sql}\n";
			}
		}
	}

	$keys = '`id`,
		`myevent` as `event`,
		`openid`,
		`license_id12` as `serialno`,
		`status`,
		`isupdate`,
		`sysname` as `name`,
		`tips`';

	$sql = "select $keys from weixin_brokennet";
	$sql.= " where (`status` != `old_status` or `isupdate` != 0) and `myevent` != ''";

	try {
		$sth = $nidb->prepare($sql);
		$ret = $sth->execute();
		if(!$ret) 
			return;
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (NiDBException $e) {
		return;
	}

	echo "count: " . count($rows) . " + " . count($other_cmd) . "\n";
	if(count($rows) <= 0 && count($other_cmd) <= 0)
		return;

	$ids = array ();

	if (($fd = fopen(API_WXDENY_FILE, 'w')) === false) {
		echo "fail: fopen " . API_WXDENY_FILE . "\n";
		return;
	}

	foreach($rows as $key => $val) {
		// 2021-03-15
		// 云堤需求，创建同步任务，1、同步日志设备ID，2、清空 云平台禁止上网域名、云平台放行上网域名 DNS群组
		// 检查是否有同步任务
		if(file_exists(API_WXDENY_DIR . '/' . $val->serialno)) 
			continue;

		if($val->isupdate == 127) {
			if(!isset($wxmsgdev[$val->serialno]))
				$wxmsgdev[$val->serialno] = 1;
			else
				$wxmsgdev[$val->serialno]++;
		}
		
		if(strpos($val->event, "W:") === 0)
			$event = substr($val->event, 2);
		else
			$event = $val->event;

		if(is_ipstr($event)) {
			if($val->status) {
				if($val->isupdate == 127) {
					$data['ip']['allow']++;
				}
				$text = "allow=ip ip={$val->event} device={$val->serialno}";
			}
			else {
				$text = "deny=ip ip={$val->event} device={$val->serialno}";
			}
			array_push($ids, $val->id);
		}
		else {
			if($val->status) {
				if($val->isupdate == 127) {
					$data['host']['allow']++;
				}
				$text = "allow=host host={$val->event} device={$val->serialno}";
			}
			else {
				if($val->isupdate == 127) {
					$data['host']['deny']++;
				}
				$text = "deny=host host={$val->event} device={$val->serialno}";
			}
			array_push($ids, $val->id);
		}
		fwrite($fd, $text . "\n");
		if($first == "")
			$first = $text;
	}
	foreach($other_cmd as $text) 
		fwrite($fd, $text . "\n");

	fclose($fd);

	$rulecnt = 0;
	foreach($wxmsgdev as $val)
		$rulecnt+= $val;

	if($rulecnt > 1) {
		$tag = array();
		foreach($data as $key => $val) {
			if($data[$key]['allow'])
				array_push($tag, "allow=$key count=" . $data[$key]['allow']);
			if($data[$key]['deny'])
				array_push($tag, "deny=$key count=" . $data[$key]['deny']);
		}
		$tag = implode(" ", $tag);
	}
	else
		$tag = $first;

	if(count($rows) <= 0 && strlen($retd) <= 0)
		return;
	
	if(count($rows) <= 0)
		$tag = $retd;
	
	$cmd = CLOUDEYE . " device set wxcmd=1 file=" . API_WXDENY_FILE;
	exec($cmd, $out, $ret);
	if($ret != 0)
		return;

	sleep(5);
	unset($out);
	
	$msg = array(
		'send'	=> 0,
		'succ'	=> 0,
		'fail'	=> 0
	);
	for($i = 0; $i < 3; $i++) {
		$cmd = CLOUDEYE . " device set wxcmd=1 wxcmdstatus=1";
		exec($cmd, $out, $ret);
		if($ret != 0)
			return;

		foreach($out as $line) {
			$node = explode('=', $line);
			if(count($node) == 2 && isset($msg[$node[0]]))
				$msg[$node[0]] = $node[1];
		}
		if($msg['send'] > 0 || $msg['succ'] > 0 || $msg['fail'] > 0)
			break;
		sleep(2);
		unset($out);
	}
	
	echo("wxmsgdev: " . count($wxmsgdev) . " rulecnt: {$rulecnt}\n");
	if(count($wxmsgdev) > 0) {
		# 发送处理结果到微信公众号
		// $send = $msg['succ'] + $msg['fail'];
		// 发送设备={$send},成功设备={$msg['succ']},失败设备={$msg['fail']}
		$tag = str_replace(array('=', ' ', "\n"), array('%3d', '%20', ""), $tag);
		$result="{$tag},发送设备=" . count($wxmsgdev) . ",规则合计={$rulecnt},";
		$data = array(
			'systype'	=> 'cloud',
			'tag'		=> 'deny_result',
			'guid'		=> $guid,
			'md5'		=> $md5,
			'res'		=> $result
		);
		$url = "https://115.29.138.209/wxcloud/sendresult.php";
		// $url.= "?systype=cloud&guid={$guid}&tag=deny_result&md5={$md5}&res={$result}";
		$ret = httpPost($url, $data, true);
		echo "url: {$url}\n";
	}

	// 更新执行状态。
	if(count($ids) > 1) {
		$idstr = '?';
		$idstr .= str_repeat(',?' , count($ids) - 1);
		
		$sql = "update weixin_brokennet set `isupdate` = 0 where `id` in($idstr)";
		try {
			$sth = $nidb->prepare($sql);
			$ret = $sth->execute($ids);
		}
		catch (\NiDBException $e) {
			echo "NiDBException: {$sql}\n";
		}
	}
}

sync_task();
scan_wxdeny();
