<?php
session_start();
include(dirname(__file__)."/../../../common.php");
if (!chksession()) {
	outputres("no", "登录时间已过期请重新登录.");
	exit;
}

$doc = $_SERVER["DOCUMENT_ROOT"];
$action = isset($_POST["action"]) ? postval("action") : "";

$ipfw_conf = $doc."/app/ipfw/ipfw.conf";

function ipfw_split($str)
{
	$ds = explode('=', trim($str));

	return $ds[1];
}

function ipfw_remove($id)
{
	global $ipfw_conf;
	$ipfw_conf_tmp = $ipfw_conf.".tmp";

	if (!file_exists($ipfw_conf))
		return false;

	if (($fp = fopen($ipfw_conf_tmp, "w")) == false)
		return false;

	$lists = file($ipfw_conf);
	foreach($lists as $val) {
		list($vid, $vdesc, $vdir, $vintype, $vouttype, $vsrcip, $vsrcport, $vdstip, $vdstport, $vproto, $vact) = explode(' ', $val);
		if ($vid == "id=$id")
			continue;
		fprintf($fp, $val);
	}
	fclose($fp);

	rename($ipfw_conf_tmp, $ipfw_conf);

	return true;
}

function ipfw_get($id)
{
	global $ipfw_conf;

	if (!file_exists($ipfw_conf))
		return false;

	$lists = file($ipfw_conf);
	foreach($lists as $val) {
		list($vid, $vdesc, $vdir, $vintype, $vouttype, $vsrcip, $vsrcport, $vdstip, $vdstport, $vproto, $vact) = explode(' ', $val);
		if ($vid == "id=$id")
			return $val;
	}

	return false;
}

if ($action == "editrule")
{
	$id		= postval("id");
	$desc		= postval("desc");
	$dir		= postval("dir");
	$intype		= postval("intype");
	$outtype	= postval("outtype");
	$srcip		= postval("srcip");
	$srcport	= postval("srcport");
	$dstip		= postval("dstip");
	$dstport	= postval("dstport");
	$proto		= postval("proto");
	$act		= postval("act");

	if ($id == 65535) {
		outputres("no", "此编号已经存在.");
		exit;
	}

	ipfw_remove($id);

	$rule = "id=$id desc=$desc dir=$dir intype=$intype outtype=$outtype srcip=$srcip";
	$rule .= " srcport=$srcport dstip=$dstip dstport=$dstport proto=$proto act=$act";
	file_put_contents($ipfw_conf, $rule, FILE_APPEND);
	file_put_contents($ipfw_conf, "\n", FILE_APPEND);

	/* 检测ipfw是否是开启状态 */
	unset($out);
	$cmd = $doc."/app/ipfw/appctrl status";
	exec($cmd, $out, $ret);
	if (trim($out[0]) == "enable") {
		$cmd = $doc."/app/ipfw/appctrl stop";
		system($cmd);
		$cmd = $doc."/app/ipfw/appctrl start";
		system($cmd);
	}

	outputres("yes", "操作成功");
}

if ($action == "getrule")
{
	$id = postval("id");
	
	if (($obj = ipfw_get($id)) == false) {
		outputres("no", "策略不存在");
		exit;
	}
	
	list($vid, $vdesc, $vdir, $vintype, $vouttype, $vsrcip, $vsrcport, $vdstip, $vdstport, $vproto, $vact) = explode(' ', $obj);
	$rows = array(
		"id"		=>ipfw_split($vid),
		"desc"		=>ipfw_split($vdesc),
		"dir"		=>ipfw_split($vdir),
		"intype"	=>ipfw_split($vintype),
		"outtype"	=>ipfw_split($vouttype),
		"srcip"		=>ipfw_split($vsrcip),
		"srcport"	=>ipfw_split($vsrcport),
		"dstip"		=>ipfw_split($vdstip),
		"dstport"	=>ipfw_split($vdstport),
		"proto"		=>ipfw_split($vproto),
		"act"		=>ipfw_split($vact)
	);

	echo json_encode($rows);
	exit;
}

if ($action == "deleterule")
{
	$id = postval("id");

	if ($id == 65535) {
		outputres("no", "此策略不可操作");
		exit;
	}

	if (ipfw_get($id) == false) {
		outputres("no", "此策略不存在");
		exit;
	}

	if (ipfw_remove($id) == false) {
		outputres("no", "操作失败");
		exit;
	}

	/* 检测ipfw是否是开启状态 */
	unset($out);
	$cmd = $doc."/app/ipfw/appctrl status";
	exec($cmd, $out, $ret);
	if (trim($out[0]) == "enable") {
		$cmd = $doc."/app/ipfw/appctrl stop";
		system($cmd);
		$cmd = $doc."/app/ipfw/appctrl start";
		system($cmd);
	}

	outputres("yes", "操作成功");
}

if ($action == "addrule")
{
	$id		= postval("id");
	$desc		= postval("desc");
	$dir		= postval("dir");
	$intype		= postval("intype");
	$outtype	= postval("outtype");
	$srcip		= postval("srcip");
	$srcport	= postval("srcport");
	$dstip		= postval("dstip");
	$dstport	= postval("dstport");
	$proto		= postval("proto");
	$act		= postval("act");

	if (ipfw_get($id) != false) {
		outputres("no", "此编号已经存在.");
		exit;
	}

	if ($id == 65535) {
		outputres("no", "此编号已经存在.");
		exit;
	}

	$rule = "id=$id desc=$desc dir=$dir intype=$intype outtype=$outtype srcip=$srcip";
	$rule .= " srcport=$srcport dstip=$dstip dstport=$dstport proto=$proto act=$act sta=1";
	file_put_contents($ipfw_conf, $rule, FILE_APPEND);
	file_put_contents($ipfw_conf, "\n", FILE_APPEND);

	/* 检测ipfw是否是开启状态 */
	unset($out);
	$cmd = $doc."/app/ipfw/appctrl status";
	exec($cmd, $out, $ret);
	if (trim($out[0]) == "enable") {
		$cmd = $doc."/app/ipfw/appctrl stop";
		system($cmd);
		$cmd = $doc."/app/ipfw/appctrl start";
		system($cmd);
	}

	outputres("yes", "操作成功");
}

if ($action == "listrule")
{
	$rows	= array();
	$sort	= array();

	if (!file_exists($ipfw_conf)) {
		$cmd = "id=888 desc=允许所有 dir=any intype=any outtype=any srcip= srcport=0 dstip= dstport=0 proto=any act=allow\n";
		file_put_contents($ipfw_conf, $cmd, FILE_APPEND);
	}

	$lists = file($ipfw_conf);
	foreach($lists as $val) {
		list($vid, $vdesc, $vdir, $vintype, $vouttype, $vsrcip, $vsrcport, $vdstip, $vdstport, $vproto, $vact) = explode(' ', $val);
		array_push($rows, array(
			"id"		=>ipfw_split($vid),
			"desc"		=>ipfw_split($vdesc),
			"dir"		=>ipfw_split($vdir),
			"intype"	=>ipfw_split($vintype),
			"outtype"	=>ipfw_split($vouttype),
			"srcip"		=>ipfw_split($vsrcip),
			"srcport"	=>ipfw_split($vsrcport),
			"dstip"		=>ipfw_split($vdstip),
			"dstport"	=>ipfw_split($vdstport),
			"proto"		=>ipfw_split($vproto),
			"act"		=>ipfw_split($vact),
			"in"		=>0,
			"out"		=>0
		));

		array_push($sort, ipfw_split($vid));
	}

	$cmd = "/sbin/ipfw -t show | awk '{print $1, $2, $3}'";
	unset($out);
	exec($cmd, $out, $ret);
	foreach($out as $val) {
		list($id, $out, $in) = explode(' ', $val);
		foreach($rows as $k=>$r) {
			if ($r["id"] == $id) {
				$rows[$k]["out"] = $out;
				$rows[$k]["in"] = $in;
				break;
			}
		}
	}

	array_multisort($sort, SORT_ASC, SORT_NUMERIC, $rows);

	echo json_encode($rows);
}

















?>
